import "DigitalUtopia.DUInterface";
import "DigitalUtopia.Utilsx";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
--import "DigitalUtopia.Utilsx.Class";

SetupWindow = class(DigitalUtopia.DUInterface.Window );

function SetupWindow:Constructor(loc)
	DigitalUtopia.DUInterface.Window.Constructor( self,575,534 );
	
	self.locale=loc;
	if(loc=="en")then
		TITLE="Palantir Options";
		MISC="Misc.";
		RECENTER="Recenter Palantir";
		SHOW_IN_COMBAT="Show Only In Combat";
		OOC_CRITERIA="Out Of Combat Criteria";
		VITALS_100="Vitals 100%";
		MORALE_100="Morale 100%";
		POWER_100="Power 100%";
		OUT_OF_COMBAT="Out Of Combat";
		SHOW_VITALS="Show Game Vitals";
		SCOPE="Settings Scope";
		ACCOUNT="Account";
		SERVER="Server";
		CHAR="Character";
		PLAYER_VITALS="Player Vitals";
		BAR_OPACITY="Bar Opacity";
		BAR_SPACING="Bar Spacing";
		TEXT_OPACITY="Text Opacity";
		DEBUFF_BAR="Debuff Bar";
		SHOW_DEBUFF="Show Debuff Bar";
		DISPLAY_MODE="Display Mode";
		DM_CURABLE="Curable Support";
		DM_INDICATOR="Indicators Only";
		DEBUFF_INDICATOR="Debuff Indicator Opacity";
		VERTICAL_POS="Vertical Position";
		COOLDOWNS="Cooldowns";
		WOUND_CD="Wound Curable Cooldown (In Seconds)";
		FEAR_CD="Fear Curable Cooldown (In Seconds)";
		DISEASE_CD="Disease Curable Cooldown (In Seconds)";
		POISON_CD="Poison Curable Cooldown (In Seconds)";
		PLAYER_MORALE="Player Morale Bar";
		PLAYER_POWER="Player Power Bar";
		BAR_COLOR="Bar Color";
		TEXT_COLOR="Text Color";
		ENABLE_CE="Enable Color Effects";
		ENABLE_CT="Enable Color Transitions";
		POINT_ONE_COLOR="Point #1 Color";
		POINT_ONE_LOC="Point #1 Location";
		ENABLE_SECOND="Enable 2nd Color";
		POINT_TWO_COLOR="Point #2 Color";
		POINT_TWO_LOC="Point #2 Location";
		GROUP_TEXT_POS="Group Text Position";
		GROUP_TEXT_DIS="Group Text Display";
		VITALS_TEXT_POS="Vitals Text Position";
		BOTTOM_OUTSIDE="Bottom Outside";
		BOTTOM_CENTER="Bottom Center";
		BOTTOM_INSIDE="Bottom Inside";
		MIDDLE_OUTSIDE="Middle Outside";
		MIDDLE_INSIDE="Middle Inside";
		TOP_OUTSIDE="Top Outside";
		TOP_CENTER="Top Center";
		TOP_INSIDE="Top Inside";
		VITALS_TEXT_DIS="Vitals Text Display";
		PCT="Percentage";
		REAL_NUMBERS="Real Numbers";
		CUR_MAX="Current/Max";
		PCT_CUR_MAX="PCT & Current/Max";
		TEXT_POSITION="Text Position";
		TEXT_DISPLAY="Text Display";
		REVERT_TEXT="Revert Text";
		REVERT_MAIN="Revert Main";
		REVERT_COLOR="Revert Color";
		DEFAULT_TEXT="Default Text";
		DEFAULT_MAIN="Default Main";
		DEFAULT_COLOR="Default Color";
		COLOR="Color";
		MAIN="Main";
		TEXT="Text";
		ACCEPT="Accept";
		YES="Yes";
		NO="No";
		ARE_YOU_SURE="Are you sure you want to restore the default settings?"
	elseif(loc=="de")then
		TITLE="Palantir Optionen";
		MISC="Verschiedenes";
		RECENTER="Palantir neuzentrieren";
		SHOW_IN_COMBAT="Nur im Kampf anzeigen";
		OOC_CRITERIA="Auerhalb-des-Kampfes-Kriterien";
		VITALS_100="Vitalwerte 100%";
		MORALE_100="Moral 100%";
		POWER_100="Kraft 100%";
		OUT_OF_COMBAT="Auerhalb des Kampfes";
		SHOW_VITALS="Spiel-Vitalwerte anzeigen";
		SCOPE="Einstellung speichern pro";
		ACCOUNT="Account";
		SERVER="Server";
		CHAR="Charakter";
		PLAYER_VITALS="Vitalwerte des Spielers";
		BAR_OPACITY="Deckkraft Leiste";
		BAR_SPACING="Abstand Leiste";
		TEXT_OPACITY="Deckkraft Text";
		DEBUFF_BAR="Debuff-Leiste";
		SHOW_DEBUFF="Debuff-Leiste anzeigen";
		DISPLAY_MODE="Anzeigemodus";
		DM_CURABLE="Heiluntersttzung";
		DM_INDICATOR="Nur Anzeige";
		DEBUFF_INDICATOR="Deckkraft Debuffanzeige";
		VERTICAL_POS="Vertikale Position";
		COOLDOWNS="Cooldowns";
		WOUND_CD="Cooldown Wundtrank (in Sekunden)";
		FEAR_CD="Cooldown Furchttrank (in Sekunden)";
		DISEASE_CD="Cooldown Krankheitstrank (in Sekunden)";
		POISON_CD="Cooldown Gifttrank (in Sekunden)";
		PLAYER_MORALE="Spieler-Moralleiste";
		PLAYER_POWER="Spieler-Kraftleiste";
		BAR_COLOR="Leistenfarbe";
		TEXT_COLOR="Textfarbe";
		ENABLE_CE="Farbeffekte aktivieren";
		ENABLE_CT="Farbbergnge aktivieren";
		POINT_ONE_COLOR="Farbe fr 1. Farbwechsel";
		POINT_ONE_LOC="1. Farbwechsel bei x%";
		ENABLE_SECOND="2. Farbe aktivieren";
		POINT_TWO_COLOR="Farbe fr 2. Farbwechsel";
		POINT_TWO_LOC="2. Farbwechsel bei x%";
		GROUP_TEXT_POS="Gleiche Position fr Vitalwerte";
		GROUP_TEXT_DIS="Gleiche Anzeige fr Vitalwerte";
		VITALS_TEXT_POS="Position Vitalwerte";
		BOTTOM_OUTSIDE="Unten Auerhalb";
		BOTTOM_CENTER="Unten Mitte";
		BOTTOM_INSIDE="Unten Innerhalb";
		MIDDLE_OUTSIDE="Mitte Auerhalb";
		MIDDLE_INSIDE="Mitte Innerhalb";
		TOP_OUTSIDE="Oben Innerhalb";
		TOP_CENTER="Oben Mitte";
		TOP_INSIDE="Oben Innerhalb";
		VITALS_TEXT_DIS="Anzeige Vitalwerte";
		PCT="Prozent";
		REAL_NUMBERS="Zahlenwert";
		CUR_MAX="Aktuell/Max.";
		PCT_CUR_MAX="Prozent & Aktuell/Max.";
		TEXT_POSITION="Textposition";
		TEXT_DISPLAY="Textanzeige";
		REVERT_TEXT="Texteinst. rckg.";
		REVERT_MAIN="Haupteinst. rckg.";
		REVERT_COLOR="Farbeinst. rckg.";
		DEFAULT_TEXT="Texteinst. Std.";
		DEFAULT_MAIN="Haupteinst. Std.";
		DEFAULT_COLOR="Farbeinst. Std.";
		COLOR="Farbe";
		MAIN="Grundeinst.";
		TEXT="Text";
		ACCEPT="bernehmen";
		YES="Ja";
		NO="Nein";
		ARE_YOU_SURE="Bist Du sicher, dass Du die Standardeinstellungen zurcksetzen willst?"

	elseif(loc=="fr")then
		TITLE="Options de Palantir";
		MISC="Divers";
		RECENTER="Recentrer Palantir";
		SHOW_IN_COMBAT="Montrer Seulement en combat";
		OOC_CRITERIA="Critre pour Hors Combat";
		VITALS_100="Carac Vitales 100%";
		MORALE_100="Moral 100%";
		POWER_100="Puissance 100%";
		OUT_OF_COMBAT="Hors Combat";
		SHOW_VITALS="Montrer les Carac Vitales";
		SCOPE="Paramtres lis ";
		ACCOUNT="Compte";
		SERVER="Serveur";
		CHAR="Personnage";
		PLAYER_VITALS="Barres Vitales";
		BAR_OPACITY="Opacit des barres";
		BAR_SPACING="Espacement des barres";
		TEXT_OPACITY="Opacit du texte";
		DEBUFF_BAR="Barre des debuffs";
		SHOW_DEBUFF="Montrer la barre des debuffs";
		DISPLAY_MODE="Mode de visualisation";
		DM_CURABLE="Barre des potions";
		DM_INDICATOR="Indicateurs seulement";
		DEBUFF_INDICATOR="Opacit des indicateurs de debuffs";
		VERTICAL_POS="Position Verticale";
		COOLDOWNS="Temps de Recharge";
		WOUND_CD="Recharge Soins Blessure (En Secondes)";
		FEAR_CD="Recharge Soins Peur (En Secondes)";
		DISEASE_CD="Recharge Soins Maladie (En Secondes)";
		POISON_CD="Recharge Soins Poison (En Secondes)";
		PLAYER_MORALE="Barre de Moral";
		PLAYER_POWER="Barre de Puissance";
		BAR_COLOR="Couleur de la Barre";
		TEXT_COLOR="Couleur du Texte";
		ENABLE_CE="Autoriser les Changements de Couleur";
		ENABLE_CT="Autoriser les Transitions de Couleur";
		POINT_ONE_COLOR="Couleur du Seuil 1";
		POINT_ONE_LOC="Niveau du Seuil 1 (en %)";
		ENABLE_SECOND="Utiliser un autre seuil / couleur";
		POINT_TWO_COLOR="Couleur du Seuil 2";
		POINT_TWO_LOC="Niveau du Seuil 2 (en %)";
		GROUP_TEXT_POS="Position Commune des Textes";
		GROUP_TEXT_DIS="Affichage Commun des Textes";
		VITALS_TEXT_POS="Position des Informations Vitales";
		BOTTOM_OUTSIDE="Bas et Extrieur";
		BOTTOM_CENTER="Bas et Centr";
		BOTTOM_INSIDE="Bas et Intrieur";
		MIDDLE_OUTSIDE="Milieu et Extrieur";
		MIDDLE_INSIDE="Milieu et Intrieur";
		TOP_OUTSIDE="Haut et Extrieur";
		TOP_CENTER="Haut et Centr";
		TOP_INSIDE="Haut et Intrieur";
		VITALS_TEXT_DIS="Affichage des Informations";
		PCT="Pourcentage";
		REAL_NUMBERS="Nombre Rel";
		CUR_MAX="Actuel/Maxi";
		PCT_CUR_MAX="P% & Actuel/Maxi";
		TEXT_POSITION="Position du Texte";
		TEXT_DISPLAY="Affichage du Texte";
		REVERT_TEXT=" Annuler Modifs Texte";
		REVERT_MAIN=" Annuler Modifs Params Gnraux";
		REVERT_COLOR=" Annuler Modifs Couleur";
		DEFAULT_TEXT=" Textes par Dfaut";
		DEFAULT_MAIN=" Paramtres par Dfaut";
		DEFAULT_COLOR=" Couleurs par Dfaut";
		COLOR="Couleur";
		MAIN="Principal";
		TEXT="Texte";
		ACCEPT="Accepter";
		YES="Oui";
		NO="Non";
		ARE_YOU_SURE="tes vous sur de vouloir restaurer les paramtres par dfaut ?"
	end

	
	self.tbHolder:SetWidth(255);
	self.tbRight:SetPosition(self.tbHolder:GetWidth()-35,0)
	self.tbHolder:SetLeft((self:GetWidth() - self.tbHolder:GetWidth())/2);
	self.tbCenter:SetSize(self.tbHolder:GetWidth()-70,42);
	self.tbCenter:SetPosition(self.tbLeft:GetLeft()+35,0)
	self.bg:SetSize(503,462);
	self.text:SetText(TITLE);
	self.text:SetWidth(self.tbHolder:GetWidth());
	self.text:SetHeight(20);
	self.text:SetLeft(-35);
	self.text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.clButton:SetPosition(self:GetWidth()-23,24)
	self.tw=Turbine.UI.Window();
	self.tw:SetVisible(true);
	self.tw:SetParent(self);
	self.tw:SetSize(575,534);
	self.tw:SetPosition(0,0);
	self.tw:SetMouseVisible(false);
	
	

	self.sb = Turbine.UI.Lotro.ScrollBar();
	self.sb:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.sb:SetParent(self.tw);
	self.sb:SetPosition(422,50);
	self.sb:SetSize(10,448);
	self.sb:SetZOrder(10);
	self.sb:SetBackColorBlendMode(0);
	self.sb:SetBlendMode(0);

	self.sp=Turbine.UI.ListBox();
	self.sp:SetParent(self.tw);
	self.sp:SetPosition(12,50);
	--self.sp:SetBackColor(Turbine.UI.Color(1,0,0));
	self.sp:SetSize(420,448);
	self.sp:SetVerticalScrollBar(self.sb);
	--self.sp:SetVisible(false);
	self.sp:SetOrientation( Turbine.UI.Orientation.Horizontal );
	self.sp:SetMaxItemsPerLine(1);
	self.sp:SetBackColorBlendMode(0);
	self.sp:SetBlendMode(4);
	self.sp.MouseClick=function(sender,args)
		self:Activate();
	end
	self.revMain=Turbine.UI.Lotro.Button();
	self.revMain:SetParent(self.tw);
	self.revMain:SetSize(128,20);
	self.revMain:SetText(REVERT_MAIN);
	self.revMain:SetPosition(32,500);
	self.revMain:SetEnabled(false);
	self.revMain.MouseDown=function(sender,args)
		self:Activate();
	end
	self.defMain=Turbine.UI.Lotro.Button();
	self.defMain:SetParent(self.tw);
	self.defMain:SetSize(128,20);
	self.defMain:SetText(DEFAULT_MAIN);
	self.defMain:SetPosition(163,500);
	self.defMain.MouseDown=function(sender,args)
		self:Activate();
	end
	self.accMain=Turbine.UI.Lotro.Button();
	self.accMain:SetParent(self.tw);
	self.accMain:SetSize(128,20);
	self.accMain:SetText(ACCEPT);
	self.accMain:SetPosition(294,500);
	self.accMain.MouseDown=function(sender,args)
		self:Activate();
	end
	self.hdr = Header();
	self.hdr.SetText(MISC);
	self.hdr:SetMouseVisible(false);
	--self.hdr:SetParent(self.tw);
	--self.hdr:SetPosition(30,60);
	self.sp:AddItem(self.hdr);
	
	self.rcHolder=Turbine.UI.Control();
	self.rcHolder:SetSize(420,30);
	self.rcHolder:SetMouseVisible(false);
	self.recenter = Turbine.UI.Lotro.Button();
	self.recenter:SetText(RECENTER);
	self.recenter:SetWidth(160);
	self.recenter:SetLeft(248);
	self.recenter:SetParent(self.rcHolder);
	self.recenter.MouseDown=function(sender,args)
		self:Activate();
	end
	self.sp:AddItem(self.rcHolder);
	self.sicHolder=Turbine.UI.Control();
	self.sicHolder:SetSize(420,30);
	self.sicHolder:SetMouseVisible(false);
	self.showincombat = DigitalUtopia.DUInterface.CheckBox(3);
	self.showincombat:SetChecked(true);
	self.showincombat:SetText(SHOW_IN_COMBAT);
	self.showincombat:SetParent(self.sicHolder);
	self.showincombat:SetLeft(55);
	self.showincombat.doActive=function()
		self:Activate();
	end
	--self.showincombat:SetWidth(166);
	self.sp:AddItem(self.sicHolder); 
	

	
	self.nocHolder=Turbine.UI.Control();
	self.nocHolder:SetSize(420,30);
	self.nocHolder:SetMouseVisible(false);
	self.noc = DigitalUtopia.DUInterface.DropDownBox({VITALS_100,MORALE_100,POWER_100,OUT_OF_COMBAT});
	self.noc:SetParent(self.nocHolder);
	self.noc:SetPosition(246,0);
	self.noc.doActive=function()
		self:Activate();
	end
	self.nocPanel=Turbine.UI.Window();
	self.nocPanel:SetVisible(true);
	self.nocPanel:SetParent(self.sp);
	self.nocPanel:SetPosition(0,0);
	self.nocPanel:SetSize(480,448);
	self.nocPanel:SetZOrder(99);
	self.nocPanel:SetVisible(false);
	self.nocLb = self.noc.listBox; 
	self.nocLb:SetParent(self.nocPanel);
	self.nocLb:SetZOrder(99);
	self.nocLb:SetBlendMode(0);
	self.nocLb:SetBackColorBlendMode(0);
	self.nocLb:SetPosition(200,200);
	self.nocLabel=Turbine.UI.Label();
	self.nocLabel:SetParent(self.nocHolder);
	self.nocLabel:SetPosition(0,0);
	self.nocLabel:SetSize(246,20);
	self.nocLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.nocLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.nocLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.nocLabel:SetText(OOC_CRITERIA);
	self.nocLabel:SetMouseVisible(false);
	self.sp:AddItem(self.nocHolder);
	
	self.svHolder=Turbine.UI.Control();
	self.svHolder:SetSize(420,30);
	self.svHolder:SetMouseVisible(false);
	self.sv = DigitalUtopia.DUInterface.CheckBox(3);
	self.sv:SetChecked(true);
	self.sv:SetText(SHOW_VITALS);
	self.sv:SetParent(self.svHolder);
	self.sv:SetLeft(55);
	self.sv.doActive=function()
		self:Activate();
	end
	self.sp:AddItem(self.svHolder); 
	
	self.acHolder=Turbine.UI.Control();
	self.acHolder:SetSize(420,30);
	self.acHolder:SetMouseVisible(false);
	self.ac = DigitalUtopia.DUInterface.DropDownBox({ACCOUNT,CHAR,SERVER});
	self.ac:SetParent(self.acHolder);
	self.ac:SetPosition(246,0);
	self.ac.doActive=function()
		self:Activate();
	end
	self.acPanel=Turbine.UI.Window();
	self.acPanel:SetVisible(true);
	self.acPanel:SetParent(self.sp);
	self.acPanel:SetPosition(0,0);
	self.acPanel:SetSize(480,448);
	self.acPanel:SetZOrder(99);
	self.acPanel:SetVisible(false);
	self.acLb = self.ac.listBox; 
	self.acLb:SetParent(self.acPanel);
	self.acLb:SetZOrder(99);
	self.acLb:SetBlendMode(0);
	self.acLb:SetBackColorBlendMode(0);
	self.acLb:SetPosition(200,200);
	self.acLabel=Turbine.UI.Label();
	self.acLabel:SetParent(self.acHolder);
	self.acLabel:SetPosition(0,0);
	self.acLabel:SetSize(246,20);
	self.acLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.acLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.acLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.acLabel:SetText(SCOPE);
	self.acLabel:SetMouseVisible(false);
	self.sp:AddItem(self.acHolder);

	self.vitHdr=Header();
	self.vitHdr.SetText(PLAYER_VITALS);
	self.vitHdr:SetMouseVisible(false);
	self.sp:AddItem(self.vitHdr);
	
	self.voHolder = Turbine.UI.Control();
	self.voHolder:SetSize(420,45);
	self.voHolder:SetMouseVisible(false);
	self.voSld = DigitalUtopia.DUInterface.Slider();
	self.voSld:SetParent(self.voHolder);
	self.voSld:SetLeft(57);
	self.voSld:SetText(BAR_OPACITY);
	self.voSld.doActive=function()
		self:Activate();
	end
	self.sp:AddItem(self.voHolder);
	
	self.bpHolder = Turbine.UI.Control();
	self.bpHolder:SetSize(420,45);
	self.bpHolder:SetMouseVisible(false);
	self.bpSld = DigitalUtopia.DUInterface.Slider();
	self.bpSld:SetParent(self.bpHolder);
	self.bpSld:SetLeft(57);
	self.bpSld:SetText(BAR_SPACING);
	self.bpSld.doActive=function()
		self:Activate();
	end
	self.sp:AddItem(self.bpHolder);
	
	self.txHolder = Turbine.UI.Control();
	self.txHolder:SetSize(420,45);
	self.txHolder:SetMouseVisible(false);
	self.txSld = DigitalUtopia.DUInterface.Slider();
	self.txSld:SetParent(self.txHolder);
	self.txSld:SetLeft(57);
	self.txSld:SetText(TEXT_OPACITY);
	self.txSld.doActive=function()
		self:Activate();
	end
	self.sp:AddItem(self.txHolder);
	
	self.dbHdr=Header();
	self.dbHdr.SetText(DEBUFF_BAR);
	self.dbHdr:SetMouseVisible(false);
	self.sp:AddItem(self.dbHdr);

	self.sdbHolder=Turbine.UI.Window();
	self.sdbHolder:SetVisible(true);
	self.sdbHolder:SetSize(420,30);
	self.sdbHolder:SetMouseVisible(false);
	self.sdb = DigitalUtopia.DUInterface.CheckBox(3);
	self.sdb:SetChecked(true);
	self.sdb:SetText(SHOW_DEBUFF);
	self.sdb:SetParent(self.sdbHolder);
	self.sdb:SetLeft(55);
	self.sdb.doActive=function()
		self:Activate();
	end
	self.sp:AddItem(self.sdbHolder); 	
	
	self.debuffDisplayHolder=Turbine.UI.Control();
	self.debuffDisplayHolder:SetSize(420,30);
	self.debuffDisplayHolder:SetMouseVisible(false);
	self.debuffDisplay = DigitalUtopia.DUInterface.DropDownBox({DM_INDICATOR,DM_CURABLE});
	self.debuffDisplay:SetParent(self.debuffDisplayHolder);
	self.debuffDisplay:SetPosition(246,0);
	self.debuffDisplay.doActive=function()
		self:Activate();
	end
	self.debuffDisplayPanel=Turbine.UI.Window();
	self.debuffDisplayPanel:SetVisible(true);
	self.debuffDisplayPanel:SetParent(self.sp);
	self.debuffDisplayPanel:SetPosition(0,0);
	self.debuffDisplayPanel:SetSize(480,448);
	self.debuffDisplayPanel:SetZOrder(99);
	self.debuffDisplayPanel:SetVisible(false);
	self.debuffDisplayLb = self.debuffDisplay.listBox; 
	self.debuffDisplayLb:SetParent(self.debuffDisplayPanel);
	self.debuffDisplayLb:SetZOrder(99);
	self.debuffDisplayLb:SetBlendMode(0);
	self.debuffDisplayLb:SetBackColorBlendMode(0);
	self.debuffDisplayLb:SetPosition(200,200);
	self.debuffDisplayLabel=Turbine.UI.Label();
	self.debuffDisplayLabel:SetParent(self.debuffDisplayHolder);
	self.debuffDisplayLabel:SetPosition(0,0);
	self.debuffDisplayLabel:SetSize(246,20);
	self.debuffDisplayLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.debuffDisplayLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.debuffDisplayLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.debuffDisplayLabel:SetText(DISPLAY_MODE);
	self.debuffDisplayLabel:SetMouseVisible(false);
	self.sp:AddItem(self.debuffDisplayHolder);
	
		self.debuffDisplayPanel.MouseClick=function(sender,args)
		self.debuffDisplay.Close();
		self.debuffDisplayPanel:SetVisible(false);
	end


	self.debuffDisplay.Opening =function()
		self.debuffDisplayPanel:SetVisible(true);
		tl,tt=self.debuffDisplayHolder:PointToScreen(self.debuffDisplayHolder:GetPosition());
		self.debuffDisplayLb:SetPosition(246,self.debuffDisplayHolder:GetTop()+21);
		
	end
	
	self.dboHolder = Turbine.UI.Control();
	self.dboHolder:SetSize(420,45);
	self.dboHolder:SetMouseVisible(false);
	self.dboSld = DigitalUtopia.DUInterface.Slider();
	self.dboSld:SetParent(self.dboHolder);
	self.dboSld:SetLeft(57);
	self.dboSld:SetText(BAR_OPACITY);
	self.dboSld.doActive=function()
		self:Activate();
	end
	self.sp:AddItem(self.dboHolder);
	
	self.dbiHolder = Turbine.UI.Control();
	self.dbiHolder:SetSize(420,45);
	self.dbiHolder:SetMouseVisible(false);
	self.dbiSld = DigitalUtopia.DUInterface.Slider();
	self.dbiSld:SetParent(self.dbiHolder);
	self.dbiSld:SetLeft(57);
	self.dbiSld:SetText(DEBUFF_INDICATOR);
	self.dbiSld.doActive=function()
		self:Activate();
	end
	self.sp:AddItem(self.dbiHolder);
	
	self.dbpHolder = Turbine.UI.Control();
	self.dbpHolder:SetSize(420,45);
	self.dbpHolder:SetMouseVisible(false);
	self.dbpSld = DigitalUtopia.DUInterface.Slider();
	self.dbpSld:SetParent(self.dbpHolder);
	self.dbpSld:SetLeft(57);
	self.dbpSld:SetText(VERTICAL_POS);
	self.dbpSld:SetMinMax(0,1);
	self.dbpSld.doActive=function()
		self:Activate();
	end
	self.sp:AddItem(self.dbpHolder);
	
	self.cdHdr=Header();
	self.cdHdr.SetText(COOLDOWNS);
	self.cdHdr:SetMouseVisible(false);
	self.sp:AddItem(self.cdHdr);
	
	self.wndHolder=Turbine.UI.Control();
	self.wndHolder:SetSize(420,30);
	self.wndHolder:SetZOrder(40);
	self.wndHolder:SetMouseVisible(false);
	self.wnd = Turbine.UI.Lotro.TextBox();
	self.wnd:SetParent(self.wndHolder);
	self.wnd:SetPosition(316,0);
	self.wnd:SetSize(89,20);
	self.wnd:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.wnd:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.wnd:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.wnd:SetBlendMode(0);
	self.wnd:SetBackColorBlendMode(0);
	self.wnd:SetMultiline(false);
	self.wnd:SetWantsKeyEvents(true);

	self.wndLabel=Turbine.UI.Label();
	self.wndLabel:SetParent(self.wndHolder);
	self.wndLabel:SetPosition(0,0);
	self.wndLabel:SetSize(315,20);
	self.wndLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.wndLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.wndLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.wndLabel:SetText(WOUND_CD);
	self.wndLabel:SetMouseVisible(false);
	self.wnd:SetText("0");
	self.sp:AddItem(self.wndHolder);
	
	self.frHolder=Turbine.UI.Control();
	self.frHolder:SetSize(420,30);
	self.frHolder:SetZOrder(40);
	self.frHolder:SetMouseVisible(false);
	self.fr = Turbine.UI.Lotro.TextBox();
	self.fr:SetParent(self.frHolder);
	self.fr:SetPosition(316,0);
	self.fr:SetSize(89,20);
	self.fr:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.fr:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.fr:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.fr:SetBlendMode(0);
	self.fr:SetBackColorBlendMode(0);
	self.fr:SetWantsKeyEvents(true);
	self.fr:SetMultiline(false);
	self.frLabel=Turbine.UI.Label();
	self.frLabel:SetParent(self.frHolder);
	self.frLabel:SetPosition(0,0);
	self.frLabel:SetSize(315,20);
	self.frLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.frLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.frLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.frLabel:SetText(FEAR_CD);
	self.frLabel:SetMouseVisible(false);
	self.fr:SetText("0");
	self.sp:AddItem(self.frHolder);
	
	self.disHolder=Turbine.UI.Control();
	self.disHolder:SetSize(420,30);
	self.disHolder:SetZOrder(40);
	self.disHolder:SetMouseVisible(false);
	self.dis = Turbine.UI.Lotro.TextBox();
	self.dis:SetParent(self.disHolder);
	self.dis:SetPosition(316,0);
	self.dis:SetSize(89,20);
	self.dis:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.dis:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.dis:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.dis:SetBlendMode(0);
	self.dis:SetBackColorBlendMode(0);
	self.dis:SetWantsKeyEvents(true);
	self.dis:SetMultiline(false);
	self.disLabel=Turbine.UI.Label();
	self.disLabel:SetParent(self.disHolder);
	self.disLabel:SetPosition(0,0);
	self.disLabel:SetSize(315,20);
	self.disLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.disLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.disLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.disLabel:SetText(DISEASE_CD);
	self.disLabel:SetMouseVisible(false);
	self.dis:SetText("0");
	self.sp:AddItem(self.disHolder);
	
	self.psnHolder=Turbine.UI.Control();
	self.psnHolder:SetSize(420,30);
	self.psnHolder:SetZOrder(40);
	self.psnHolder:SetMouseVisible(false);
	self.psn = Turbine.UI.Lotro.TextBox();
	self.psn:SetParent(self.psnHolder);
	self.psn:SetPosition(316,0);
	self.psn:SetSize(89,20);
	self.psn:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.psn:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.psn:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.psn:SetBlendMode(0);
	self.psn:SetBackColorBlendMode(0);
	self.psn:SetWantsKeyEvents(true);
	self.psn:SetMultiline(false);
	self.psnLabel=Turbine.UI.Label();
	self.psnLabel:SetParent(self.psnHolder);
	self.psnLabel:SetPosition(0,0);
	self.psnLabel:SetSize(315,20);
	self.psnLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.psnLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.psnLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.psnLabel:SetText(POISON_CD);
	self.psnLabel:SetMouseVisible(false);
	self.psn:SetText("0");
	self.sp:AddItem(self.psnHolder);
	
	-- Text Panel--
		self.txw=Turbine.UI.Window();
		self.txw:SetVisible(true);
	self.txw:SetParent(self);
	self.txw:SetSize(575,534);
	self.txw:SetPosition(0,0);
	self.txw:SetMouseVisible(false);
	self.txw:SetVisible(false);
		
		self.sbt = Turbine.UI.Lotro.ScrollBar();
	self.sbt:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.sbt:SetParent(self.txw);
	self.sbt:SetPosition(422,50);
	self.sbt:SetSize(10,448);
	self.sbt:SetZOrder(10);
	self.sbt:SetBackColorBlendMode(0);
	self.sbt:SetBlendMode(0);
	--self.sbt:SetVisible(false);
	
	self.txtPanel=Turbine.UI.ListBox();
	self.txtPanel:SetParent(self.txw);
	self.txtPanel:SetPosition(12,50);
	--self.sp:SetBackColor(Turbine.UI.Color(1,0,0));
	self.txtPanel:SetSize(420,448);
	self.txtPanel:SetVerticalScrollBar(self.sbt);
	--self.sp:SetVisible(false);
	self.txtPanel:SetOrientation( Turbine.UI.Orientation.Horizontal );
	self.txtPanel:SetMaxItemsPerLine(1);
	self.txtPanel:SetBackColorBlendMode(0);
	self.txtPanel:SetBlendMode(0);
	--self.txtPanel:SetVisible(false);
	self.txtPanel.MouseDown=function(sender,args)
		self:Activate();
	end
	self.revText=Turbine.UI.Lotro.Button();
	self.revText:SetParent(self.txw);
	self.revText:SetSize(128,20);
	self.revText:SetText(REVERT_TEXT);
	self.revText:SetPosition(32,500);
	self.revText:SetEnabled(false);
	self.revText.MouseDown=function(sender,args)
		self:Activate();
	end
	self.defText=Turbine.UI.Lotro.Button();
	self.defText:SetParent(self.txw);
	self.defText:SetSize(128,20);
	self.defText:SetText(DEFAULT_TEXT);
	self.defText:SetPosition(163,500);
	self.defText.MouseDown=function(sender,args)
		self:Activate();
	end
	self.accText=Turbine.UI.Lotro.Button();
	self.accText:SetParent(self.txw);
	self.accText:SetSize(128,20);
	self.accText:SetText(ACCEPT);
	self.accText:SetPosition(294,500);
	self.accText.MouseDown=function(sender,args)
		self:Activate();
	end
	self.pvtHdr=Header();
	self.pvtHdr.SetText(PLAYER_VITALS);
	
	self.txtPanel:AddItem(self.pvtHdr);
	
	self.gTxtPosHolder=Turbine.UI.Control();
	self.gTxtPosHolder:SetSize(420,30);
	self.gTxtPosHolder:SetMouseVisible(false);
	self.gTxtPos = DigitalUtopia.DUInterface.CheckBox(3);
	self.gTxtPos:SetChecked(true);
	self.gTxtPos:SetText(GROUP_TEXT_POS);
	self.gTxtPos:SetParent(self.gTxtPosHolder);
	self.gTxtPos:SetLeft(55);
	self.gTxtPos.doActive=function()
		self:Activate();
	end
	self.txtPanel:AddItem(self.gTxtPosHolder); 
	
	self.txtPosHolder=Turbine.UI.Control();
	self.txtPosHolder:SetSize(420,30);
	self.txtPosHolder:SetMouseVisible(false);
	self.txtPos = DigitalUtopia.DUInterface.DropDownBox({BOTTOM_OUTSIDE,BOTTOM_CENTER,BOTTOM_INSIDE,MIDDLE_OUTSIDE,MIDDLE_INSIDE,TOP_OUTSIDE,TOP_CENTER,TOP_INSIDE});
	self.txtPos:SetParent(self.txtPosHolder);
	self.txtPos:SetPosition(246,0);
	self.txtPos.doActive=function()
		self:Activate();
	end
	self.txtPosPanel=Turbine.UI.Window();
	self.txtPosPanel:SetVisible(true);
	self.txtPosPanel:SetParent(self.txtPanel);
	self.txtPosPanel:SetPosition(0,0);
	self.txtPosPanel:SetSize(480,448);
	self.txtPosPanel:SetZOrder(99);
	self.txtPosPanel:SetVisible(false);
	self.txtPosLb = self.txtPos.listBox; 
	self.txtPosLb:SetParent(self.txtPosPanel);
	self.txtPosLb:SetZOrder(99);
	self.txtPosLb:SetBlendMode(0);
	self.txtPosLb:SetBackColorBlendMode(0);
	self.txtPosLb:SetPosition(200,200);
	self.txtPosLabel=Turbine.UI.Label();
	self.txtPosLabel:SetParent(self.txtPosHolder);
	self.txtPosLabel:SetPosition(0,0);
	self.txtPosLabel:SetSize(246,20);
	self.txtPosLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.txtPosLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.txtPosLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.txtPosLabel:SetText(VITALS_TEXT_POS);
	self.txtPosLabel:SetMouseVisible(false);
	self.txtPanel:AddItem(self.txtPosHolder);
	
	self.txtPosPanel.MouseClick=function(sender,args)
		self.txtPos.Close();
		self.txtPosPanel:SetVisible(false);
	end


	self.txtPos.Opening =function()
		self.txtPosPanel:SetVisible(true);
		self.txtPosLb:SetPosition(246,self.txtPosHolder:GetTop()+21);
		
	end
	
	self.gTxtDisHolder=Turbine.UI.Control();
	self.gTxtDisHolder:SetSize(420,30);
	self.gTxtDisHolder:SetMouseVisible(false);
	self.gTxtDis = DigitalUtopia.DUInterface.CheckBox(3);
	self.gTxtDis:SetChecked(true);
	self.gTxtDis:SetText(GROUP_TEXT_DIS);
	self.gTxtDis:SetParent(self.gTxtDisHolder);
	self.gTxtDis:SetLeft(55);
	self.gTxtDis.doActive=function()
		self:Activate();
	end
	self.txtPanel:AddItem(self.gTxtDisHolder); 
	
		self.txtDisHolder=Turbine.UI.Control();
	self.txtDisHolder:SetSize(420,30);
	self.txtDisHolder:SetMouseVisible(false);
	self.txtDis = DigitalUtopia.DUInterface.DropDownBox({PCT,REAL_NUMBERS,CUR_MAX,PCT_CUR_MAX});
	self.txtDis:SetParent(self.txtDisHolder);
	self.txtDis:SetPosition(246,0);
	self.txtDis.doActive=function()
		self:Activate();
	end
	self.txtDisPanel=Turbine.UI.Window();
	self.txtDisPanel:SetVisible(true);
	self.txtDisPanel:SetParent(self.txtPanel);
	self.txtDisPanel:SetPosition(0,0);
	self.txtDisPanel:SetSize(480,448);
	self.txtDisPanel:SetZOrder(99);
	self.txtDisPanel:SetVisible(false);
	self.txtDisLb = self.txtDis.listBox; 
	self.txtDisLb:SetParent(self.txtDisPanel);
	self.txtDisLb:SetZOrder(99);
	self.txtDisLb:SetBlendMode(0);
	self.txtDisLb:SetBackColorBlendMode(0);
	self.txtDisLb:SetPosition(200,200);
	self.txtDisLabel=Turbine.UI.Label();
	self.txtDisLabel:SetParent(self.txtDisHolder);
	self.txtDisLabel:SetPosition(0,0);
	self.txtDisLabel:SetSize(246,20);
	self.txtDisLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.txtDisLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.txtDisLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.txtDisLabel:SetText(VITALS_TEXT_DIS);
	self.txtDisLabel:SetMouseVisible(false);
	self.txtPanel:AddItem(self.txtDisHolder);
	
	self.txtDisPanel.MouseClick=function(sender,args)
		self.txtDis.Close();
		self.txtDisPanel:SetVisible(false);
	end


	self.txtDis.Opening =function()
		self.txtDisPanel:SetVisible(true);
		self.txtDisLb:SetPosition(246,self.txtDisHolder:GetTop()+21);
		
	end
	
	self.pmtHdr=Header();
	self.pmtHdr.SetText(PLAYER_MORALE);
	self.txtPanel:AddItem(self.pmtHdr);
		
	self.pmbTxtPosHolder=Turbine.UI.Control();
	self.pmbTxtPosHolder:SetSize(420,30);
	self.pmbTxtPosHolder:SetMouseVisible(false);
	self.pmbTxtPos = DigitalUtopia.DUInterface.DropDownBox({BOTTOM_OUTSIDE,BOTTOM_CENTER,BOTTOM_INSIDE,MIDDLE_OUTSIDE,MIDDLE_INSIDE,TOP_OUTSIDE,TOP_CENTER,TOP_INSIDE});
	self.pmbTxtPos:SetParent(self.pmbTxtPosHolder);
	self.pmbTxtPos:SetPosition(246,0);
	self.pmbTxtPos.doActive=function()
		self:Activate();
	end
	self.pmbTxtPosPanel=Turbine.UI.Window();
	self.pmbTxtPosPanel:SetVisible(true);
	self.pmbTxtPosPanel:SetParent(self.txtPanel);
	self.pmbTxtPosPanel:SetPosition(0,0);
	self.pmbTxtPosPanel:SetSize(480,448);
	self.pmbTxtPosPanel:SetZOrder(99);
	self.pmbTxtPosPanel:SetVisible(false);
	self.pmbTxtPosLb = self.pmbTxtPos.listBox; 
	self.pmbTxtPosLb:SetParent(self.pmbTxtPosPanel);
	self.pmbTxtPosLb:SetZOrder(99);
	self.pmbTxtPosLb:SetBlendMode(0);
	self.pmbTxtPosLb:SetBackColorBlendMode(0);
	self.pmbTxtPosLb:SetPosition(200,200);
	self.pmbTxtPosLabel=Turbine.UI.Label();
	self.pmbTxtPosLabel:SetParent(self.pmbTxtPosHolder);
	self.pmbTxtPosLabel:SetPosition(0,0);
	self.pmbTxtPosLabel:SetSize(246,20);
	self.pmbTxtPosLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.pmbTxtPosLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.pmbTxtPosLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.pmbTxtPosLabel:SetText(TEXT_POSITION);
	self.pmbTxtPosLabel:SetMouseVisible(false);
	self.txtPanel:AddItem(self.pmbTxtPosHolder);
	
	self.pmbTxtPosPanel.MouseClick=function(sender,args)
		self.pmbTxtPos.Close();
		self.pmbTxtPosPanel:SetVisible(false);
	end


	self.pmbTxtPos.Opening =function()
		self.pmbTxtPosPanel:SetVisible(true);
		self.pmbTxtPosLb:SetPosition(246,self.pmbTxtPosHolder:GetTop()+21);
		
	end
	
		
		self.pmbTxtDisHolder=Turbine.UI.Control();
	self.pmbTxtDisHolder:SetSize(420,30);
	self.pmbTxtDisHolder:SetMouseVisible(false);
	self.pmbTxtDis = DigitalUtopia.DUInterface.DropDownBox({PCT,REAL_NUMBERS,CUR_MAX,PCT_CUR_MAX});
	self.pmbTxtDis:SetParent(self.pmbTxtDisHolder);
	self.pmbTxtDis:SetPosition(246,0);
	self.pmbTxtDisPanel=Turbine.UI.Window();
	self.pmbTxtDisPanel:SetVisible(true);
	self.pmbTxtDisPanel:SetParent(self.txtPanel);
	self.pmbTxtDisPanel:SetPosition(0,0);
	self.pmbTxtDisPanel:SetSize(480,448);
	self.pmbTxtDisPanel:SetZOrder(99);
	self.pmbTxtDisPanel:SetVisible(false);
	self.pmbTxtDisLb = self.pmbTxtDis.listBox; 
	self.pmbTxtDisLb:SetParent(self.pmbTxtDisPanel);
	self.pmbTxtDisLb:SetZOrder(99);
	self.pmbTxtDisLb:SetBlendMode(0);
	self.pmbTxtDisLb:SetBackColorBlendMode(0);
	self.pmbTxtDisLb:SetPosition(200,200);
	self.pmbTxtDisLabel=Turbine.UI.Label();
	self.pmbTxtDisLabel:SetParent(self.pmbTxtDisHolder);
	self.pmbTxtDisLabel:SetPosition(0,0);
	self.pmbTxtDisLabel:SetSize(246,20);
	self.pmbTxtDisLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.pmbTxtDisLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.pmbTxtDisLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.pmbTxtDisLabel:SetText(TEXT_DISPLAY);
	self.pmbTxtDisLabel:SetMouseVisible(false);
	self.txtPanel:AddItem(self.pmbTxtDisHolder);
	
	self.pmbTxtDisPanel.MouseClick=function(sender,args)
		self.pmbTxtDis.Close();
		self.pmbTxtDisPanel:SetVisible(false);
	end


	self.pmbTxtDis.Opening =function()
		self.pmbTxtDisPanel:SetVisible(true);
		self.pmbTxtDisLb:SetPosition(246,self.pmbTxtDisHolder:GetTop()+21);
		
	end
	
	
	self.pptHdr=Header();
	self.pptHdr.SetText(PLAYER_POWER);
	self.txtPanel:AddItem(self.pptHdr);
		
	self.ppbTxtPosHolder=Turbine.UI.Control();
	self.ppbTxtPosHolder:SetSize(420,30);
	self.ppbTxtPosHolder:SetMouseVisible(false);
	self.ppbTxtPos = DigitalUtopia.DUInterface.DropDownBox({BOTTOM_OUTSIDE,BOTTOM_CENTER,BOTTOM_INSIDE,MIDDLE_OUTSIDE,MIDDLE_INSIDE,TOP_OUTSIDE,TOP_CENTER,TOP_INSIDE});
	self.ppbTxtPos:SetParent(self.ppbTxtPosHolder);
	self.ppbTxtPos.doActive=function()
		self:Activate();
	end
	self.ppbTxtPos:SetPosition(246,0);
	self.ppbTxtPosPanel=Turbine.UI.Window();
	self.ppbTxtPosPanel:SetVisible(true);
	self.ppbTxtPosPanel:SetParent(self.txtPanel);
	self.ppbTxtPosPanel:SetPosition(0,0);
	self.ppbTxtPosPanel:SetSize(480,448);
	self.ppbTxtPosPanel:SetZOrder(99);
	self.ppbTxtPosPanel:SetVisible(false);
	self.ppbTxtPosLb = self.ppbTxtPos.listBox; 
	self.ppbTxtPosLb:SetParent(self.ppbTxtPosPanel);
	self.ppbTxtPosLb:SetZOrder(99);
	self.ppbTxtPosLb:SetBlendMode(0);
	self.ppbTxtPosLb:SetBackColorBlendMode(0);
	self.ppbTxtPosLb:SetPosition(200,200);
	self.ppbTxtPosLabel=Turbine.UI.Label();
	self.ppbTxtPosLabel:SetParent(self.ppbTxtPosHolder);
	self.ppbTxtPosLabel:SetPosition(0,0);
	self.ppbTxtPosLabel:SetSize(246,20);
	self.ppbTxtPosLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.ppbTxtPosLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ppbTxtPosLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.ppbTxtPosLabel:SetText(TEXT_POSITION);
	self.ppbTxtPosLabel:SetMouseVisible(false);
	self.txtPanel:AddItem(self.ppbTxtPosHolder);
	
	self.ppbTxtPosPanel.MouseClick=function(sender,args)
		self.ppbTxtPos.Close();
		self.ppbTxtPosPanel:SetVisible(false);
	end


	self.ppbTxtPos.Opening =function()
		self.ppbTxtPosPanel:SetVisible(true);
		self.ppbTxtPosLb:SetPosition(246,self.ppbTxtPosHolder:GetTop()+21);
		
	end
	
		
		self.ppbTxtDisHolder=Turbine.UI.Control();
	self.ppbTxtDisHolder:SetSize(420,30);
	self.ppbTxtDisHolder:SetMouseVisible(false);
	self.ppbTxtDis = DigitalUtopia.DUInterface.DropDownBox({PCT,REAL_NUMBERS,CUR_MAX,PCT_CUR_MAX});
	self.ppbTxtDis:SetParent(self.ppbTxtDisHolder);
	self.ppbTxtDis:SetPosition(246,0);
	self.ppbTxtDis.doActive=function()
		self:Activate();
	end
	self.ppbTxtDisPanel=Turbine.UI.Window();
	self.ppbTxtDisPanel:SetVisible(true);
	self.ppbTxtDisPanel:SetParent(self.txtPanel);
	self.ppbTxtDisPanel:SetPosition(0,0);
	self.ppbTxtDisPanel:SetSize(480,448);
	self.ppbTxtDisPanel:SetZOrder(99);
	self.ppbTxtDisPanel:SetVisible(false);
	self.ppbTxtDisLb = self.ppbTxtDis.listBox; 
	self.ppbTxtDisLb:SetParent(self.ppbTxtDisPanel);
	self.ppbTxtDisLb:SetZOrder(99);
	self.ppbTxtDisLb:SetBlendMode(0);
	self.ppbTxtDisLb:SetBackColorBlendMode(0);
	self.ppbTxtDisLb:SetPosition(200,200);
	self.ppbTxtDisLabel=Turbine.UI.Label();
	self.ppbTxtDisLabel:SetParent(self.ppbTxtDisHolder);
	self.ppbTxtDisLabel:SetPosition(0,0);
	self.ppbTxtDisLabel:SetSize(246,20);
	self.ppbTxtDisLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.ppbTxtDisLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ppbTxtDisLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.ppbTxtDisLabel:SetText(TEXT_DISPLAY);
	self.ppbTxtDisLabel:SetMouseVisible(false);
	self.txtPanel:AddItem(self.ppbTxtDisHolder);
	
	self.ppbTxtDisPanel.MouseClick=function(sender,args)
		self.ppbTxtDis.Close();
		self.ppbTxtDisPanel:SetVisible(false);
	end


	self.ppbTxtDis.Opening =function()
		self.ppbTxtDisPanel:SetVisible(true);
		self.ppbTxtDisLb:SetPosition(246,self.ppbTxtDisHolder:GetTop()+21);
		
	end
	
	
	self.pmbBcChanged=function()
                             
	end                          
	
	self.pmbClrOneChanged=function()
                             
	end
	
	self.pmbClrTwoChanged=function()
                             
	end
	
	self.ppbBcChanged=function()
                             
	end                          
	
	self.ppbClrOneChanged=function()
                             
	end
	
	self.ppbClrTwoChanged=function()
                             
	end
	
	-- Color Panel--
		self.clw=Turbine.UI.Window();
		self.clw:SetVisible(true);
	self.clw:SetParent(self);
	self.clw:SetSize(575,534);
	self.clw:SetPosition(0,0);
	self.clw:SetMouseVisible(false);
	self.clw:SetVisible(false);
	
	self.sbc = Turbine.UI.Lotro.ScrollBar();
	self.sbc:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.sbc:SetParent(self.clw);
	self.sbc:SetPosition(422,50);
	self.sbc:SetSize(10,448);
	self.sbc:SetZOrder(10);
	self.sbc:SetBackColorBlendMode(0);
	self.sbc:SetBlendMode(0);
	--self.sbc:SetVisible(false);
	
	self.colPanel=Turbine.UI.ListBox();
	self.colPanel:SetParent(self.clw);
	self.colPanel:SetPosition(12,50);
	--self.sp:SetBackColor(Turbine.UI.Color(1,0,0));
	self.colPanel:SetSize(420,448);
	self.colPanel:SetVerticalScrollBar(self.sbc);
	--self.sp:SetVisible(false);
	self.colPanel:SetOrientation( Turbine.UI.Orientation.Horizontal );
	self.colPanel:SetMaxItemsPerLine(1);
	self.colPanel:SetBackColorBlendMode(0);
	self.colPanel:SetBlendMode(0);
	self.colPanel.MouseDown=function(sender,args)
		self:Activate();
	end
	
	self.revColor=Turbine.UI.Lotro.Button();
	self.revColor:SetParent(self.clw);
	self.revColor:SetSize(128,20);
	self.revColor:SetText(REVERT_COLOR);
	self.revColor:SetPosition(32,500);
	self.revColor:SetEnabled(false);
	self.revColor.MouseDown=function(sender,args)
		self:Activate();
	end
	self.defColor=Turbine.UI.Lotro.Button();
	self.defColor:SetParent(self.clw);
	self.defColor:SetSize(128,20);
	self.defColor:SetText(DEFAULT_COLOR);
	self.defColor:SetPosition(163,500);
	self.defColor.MouseDown=function(sender,args)
		self:Activate();
	end
	self.accColor=Turbine.UI.Lotro.Button();
	self.accColor:SetParent(self.clw);
	self.accColor:SetSize(128,20);
	self.accColor:SetText(ACCEPT);
	self.accColor:SetPosition(294,500);
	self.accColor.MouseDown=function(sender,args)
		self:Activate();
	end
	self.pmbcHdr=Header();
	self.pmbcHdr.SetText(PLAYER_MORALE);
	self.colPanel:AddItem(self.pmbcHdr);

	self.pmbBcHolder=Turbine.UI.Control();
	self.pmbBcHolder:SetSize(420,35);
	self.pmbBcHolder:SetMouseVisible(false);
	self.pmbBcLabel=Turbine.UI.Label();
	self.pmbBcLabel:SetParent(self.pmbBcHolder);
	self.pmbBcLabel:SetPosition(0,0);
	self.pmbBcLabel:SetSize(246,35);
	self.pmbBcLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.pmbBcLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.pmbBcLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.pmbBcLabel:SetText(BAR_COLOR);
	self.pmbBcLabel:SetMouseVisible(false);
	self.pmbBcColor=Turbine.UI.Lotro.TextBox();
	self.pmbBcColor:SetParent(self.pmbBcHolder);
	self.pmbBcColor:SetSize(35,25);
	self.pmbBcColor:SetPosition(265,5);
	self.pmbBcColor:SetReadOnly(true);
	self.pmbBcColor:SetMouseVisible(false);
	self.pmbBcCp=DigitalUtopia.DUInterface.ColorPicker();
	self.pmbBcCp:SetParent(self.pmbBcHolder);
	self.pmbBcCp:SetPosition(305,5);
	self.pmbBcCp.doActive=function()
		self:Activate();
	end
	self.pmbBcOL=Turbine.UI.Control();
	self.pmbBcOL:SetParent(self.pmbBcColor);
	self.pmbBcOL:SetSize(30,20);
	self.pmbBcOL:SetZOrder(5);
	self.pmbBcOL:SetPosition(2,2);
	self.pmbBcOL:SetBackColor(Turbine.UI.Color(1,0,0));
	self.pmbBcOL:SetMouseVisible(false);
	self.colPanel:AddItem(self.pmbBcHolder);
	self.pmbBcCp.ColorChanged=function(sender,args)
		self.pmbBcOL:SetBackColor(args.Color);
		self.pmbBcChanged();
	end
	
	
	self.pmbTcHolder=Turbine.UI.Control();
	self.pmbTcHolder:SetSize(420,35);
	self.pmbTcHolder:SetMouseVisible(false);
	self.pmbTcLabel=Turbine.UI.Label();
	self.pmbTcLabel:SetParent(self.pmbTcHolder);
	self.pmbTcLabel:SetPosition(0,0);
	self.pmbTcLabel:SetSize(246,35);
	self.pmbTcLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.pmbTcLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.pmbTcLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.pmbTcLabel:SetText(TEXT_COLOR);
	self.pmbTcLabel:SetMouseVisible(false);
	self.pmbTcColor=Turbine.UI.Lotro.TextBox();
	self.pmbTcColor:SetParent(self.pmbTcHolder);
	self.pmbTcColor:SetSize(35,25);
	self.pmbTcColor:SetPosition(265,5);
	self.pmbTcColor:SetReadOnly(true);
	self.pmbTcColor:SetMouseVisible(false);
	self.pmbTcCp=DigitalUtopia.DUInterface.ColorPicker();
	self.pmbTcCp:SetParent(self.pmbTcHolder);
	self.pmbTcCp:SetPosition(305,5);
	self.pmbTcCp.doActive=function()
		self:Activate();
	end
	self.pmbTcOL=Turbine.UI.Control();
	self.pmbTcOL:SetParent(self.pmbTcColor);
	self.pmbTcOL:SetSize(30,20);
	self.pmbTcOL:SetZOrder(5);
	self.pmbTcOL:SetPosition(2,2);
	self.pmbTcOL:SetBackColor(Turbine.UI.Color(1,0,0));
	self.pmbTcOL:SetMouseVisible(false);
	self.colPanel:AddItem(self.pmbTcHolder);
	self.pmbTcCp.ColorChanged=function(sender,args)
		self.pmbTcOL:SetBackColor(args.Color);
		self.pmbTcChanged();
	end
	
	
	
	
	
	
	
	self.pmbEceHolder=Turbine.UI.Control();
	self.pmbEceHolder:SetSize(420,30);
	self.pmbEceHolder:SetMouseVisible(false);
	self.pmbEce = DigitalUtopia.DUInterface.CheckBox(3);
	self.pmbEce:SetChecked(true);
	self.pmbEce:SetText(ENABLE_CE);
	self.pmbEce:SetParent(self.pmbEceHolder);
	self.pmbEce:SetLeft(55);
	self.pmbEce.doActive=function()
		self:Activate();
	end
	self.colPanel:AddItem(self.pmbEceHolder); 
	
	self.pmbEctHolder=Turbine.UI.Control();
	self.pmbEctHolder:SetSize(420,30);
	self.pmbEctHolder:SetMouseVisible(false);
	self.pmbEct = DigitalUtopia.DUInterface.CheckBox(3);
	self.pmbEct:SetChecked(true);
	self.pmbEct:SetText(ENABLE_CT);
	self.pmbEct:SetParent(self.pmbEctHolder);
	self.pmbEct:SetLeft(55);
	self.pmbEct.doActive=function()
		self:Activate();
	end
	self.colPanel:AddItem(self.pmbEctHolder); 
	
	self.pmbClrOneHolder=Turbine.UI.Control();
	self.pmbClrOneHolder:SetSize(420,35);
	self.pmbClrOneHolder:SetBackColor(Turbine.UI.Color(0.01,0,0,0));
	self.pmbClrOneHolder:SetMouseVisible(false);
	self.pmbClrOneLabel=Turbine.UI.Label();
	self.pmbClrOneLabel:SetParent(self.pmbClrOneHolder);
	self.pmbClrOneLabel:SetPosition(0,0);
	self.pmbClrOneLabel:SetSize(246,35);
	self.pmbClrOneLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.pmbClrOneLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.pmbClrOneLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.pmbClrOneLabel:SetText(POINT_ONE_COLOR);
	self.pmbClrOneLabel:SetMouseVisible(false);
	self.pmbClrOneColor=Turbine.UI.Lotro.TextBox();
	self.pmbClrOneColor:SetParent(self.pmbClrOneHolder);
	self.pmbClrOneColor:SetSize(35,25);
	self.pmbClrOneColor:SetPosition(265,5);
	self.pmbClrOneColor:SetReadOnly(true);
	self.pmbClrOneColor:SetMouseVisible(false);
	self.pmbClrOneCp=DigitalUtopia.DUInterface.ColorPicker();
	self.pmbClrOneCp:SetParent(self.pmbClrOneHolder);
	self.pmbClrOneCp:SetPosition(305,5);
	self.pmbClrOneCp.doActive=function()
		self:Activate();
	end
	self.pmbClrOneOL=Turbine.UI.Control();
	self.pmbClrOneOL:SetParent(self.pmbClrOneColor);
	self.pmbClrOneOL:SetSize(30,20);
	self.pmbClrOneOL:SetZOrder(5);
	self.pmbClrOneOL:SetPosition(2,2);
	self.pmbClrOneOL:SetBackColor(Turbine.UI.Color(1,0,0));
	self.pmbClrOneOL:SetMouseVisible(false);
	self.colPanel:AddItem(self.pmbClrOneHolder);
	self.pmbClrOneCp.ColorChanged=function(sender,args)
		self.pmbClrOneOL:SetBackColor(args.Color);
		self.pmbClrOneChanged();
	end
	
	self.pmbCpOneHolder = Turbine.UI.Control();
	self.pmbCpOneHolder:SetSize(420,45);
	self.pmbCpOneHolder:SetBackColor(Turbine.UI.Color(0.01,0,0,0));
	self.pmbCpOneHolder:SetMouseVisible(false);
	self.pmbCpOneSld = DigitalUtopia.DUInterface.Slider();
	self.pmbCpOneSld:SetStep(0.01);
	self.pmbCpOneSld:SetParent(self.pmbCpOneHolder);
	self.pmbCpOneSld:SetLeft(57);
	self.pmbCpOneSld:SetText(POINT_ONE_LOC);
	self.pmbCpOneSld.doActive=function()
		self:Activate();
	end
	self.colPanel:AddItem(self.pmbCpOneHolder);
	
	self.pmbEscHolder=Turbine.UI.Control();
	self.pmbEscHolder:SetSize(420,30);
	self.pmbEscHolder:SetMouseVisible(false);
	self.pmbEsc = DigitalUtopia.DUInterface.CheckBox(3);
	self.pmbEsc:SetChecked(true);
	self.pmbEsc:SetText(ENABLE_SECOND);
	self.pmbEsc:SetParent(self.pmbEscHolder);
	self.pmbEsc:SetLeft(55);
	self.pmbEsc.doActive=function()
		self:Activate()
	end
	self.colPanel:AddItem(self.pmbEscHolder); 
	
	self.pmbClrTwoHolder=Turbine.UI.Control();
	self.pmbClrTwoHolder:SetSize(420,35);
	self.pmbClrTwoHolder:SetBackColor(Turbine.UI.Color(0.01,0,0,0));
	self.pmbClrTwoHolder:SetMouseVisible(false);
	self.pmbClrTwoLabel=Turbine.UI.Label();
	self.pmbClrTwoLabel:SetParent(self.pmbClrTwoHolder);
	self.pmbClrTwoLabel:SetPosition(0,0);
	self.pmbClrTwoLabel:SetSize(246,35);
	self.pmbClrTwoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.pmbClrTwoLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.pmbClrTwoLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.pmbClrTwoLabel:SetText(POINT_TWO_COLOR);
	self.pmbClrTwoLabel:SetMouseVisible(false);
	self.pmbClrTwoColor=Turbine.UI.Lotro.TextBox();
	self.pmbClrTwoColor:SetParent(self.pmbClrTwoHolder);
	self.pmbClrTwoColor:SetSize(35,25);
	self.pmbClrTwoColor:SetPosition(265,5);
	self.pmbClrTwoColor:SetReadOnly(true);
	self.pmbClrTwoColor:SetMouseVisible(false);
	self.pmbClrTwoCp=DigitalUtopia.DUInterface.ColorPicker();
	self.pmbClrTwoCp:SetParent(self.pmbClrTwoHolder);
	self.pmbClrTwoCp:SetPosition(305,5);
	self.pmbClrTwoCp.doActive=function()
		self:Activate();
	end
	self.pmbClrTwoOL=Turbine.UI.Control();
	self.pmbClrTwoOL:SetParent(self.pmbClrTwoColor);
	self.pmbClrTwoOL:SetSize(30,20);
	self.pmbClrTwoOL:SetZOrder(5);
	self.pmbClrTwoOL:SetPosition(2,2);
	self.pmbClrTwoOL:SetBackColor(Turbine.UI.Color(1,0,0));
	self.pmbClrTwoOL:SetMouseVisible(false);
	self.colPanel:AddItem(self.pmbClrTwoHolder);
	self.pmbClrTwoCp.ColorChanged=function(sender,args)
		self.pmbClrTwoOL:SetBackColor(args.Color);
		self.pmbClrTwoChanged();
	end
	
	self.pmbCpTwoHolder = Turbine.UI.Control();
	self.pmbCpTwoHolder:SetSize(420,45);
	self.pmbCpTwoHolder:SetBackColor(Turbine.UI.Color(0.01,0,0,0));
	self.pmbCpTwoHolder:SetMouseVisible(false);
	self.pmbCpTwoSld = DigitalUtopia.DUInterface.Slider();
	self.pmbCpTwoSld:SetStep(0.01);
	self.pmbCpTwoSld:SetParent(self.pmbCpTwoHolder);
	self.pmbCpTwoSld:SetLeft(57);
	self.pmbCpTwoSld:SetText(POINT_TWO_LOC);
	self.pmbCpTwoSld.doActive=function()
		self:Activate();
	end
	self.colPanel:AddItem(self.pmbCpTwoHolder);
	
	
		self.ppbcHdr=Header();
	self.ppbcHdr.SetText(PLAYER_POWER);
	self.colPanel:AddItem(self.ppbcHdr);

	self.ppbBcHolder=Turbine.UI.Control();
	self.ppbBcHolder:SetSize(420,35);
	self.ppbBcHolder:SetMouseVisible(false);
	self.ppbBcLabel=Turbine.UI.Label();
	self.ppbBcLabel:SetParent(self.ppbBcHolder);
	self.ppbBcLabel:SetPosition(0,0);
	self.ppbBcLabel:SetSize(246,35);
	self.ppbBcLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.ppbBcLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ppbBcLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.ppbBcLabel:SetText(BAR_COLOR);
	self.ppbBcLabel:SetMouseVisible(false);
	self.ppbBcColor=Turbine.UI.Lotro.TextBox();
	self.ppbBcColor:SetParent(self.ppbBcHolder);
	self.ppbBcColor:SetSize(35,25);
	self.ppbBcColor:SetPosition(265,5);
	self.ppbBcColor:SetReadOnly(true);
	self.ppbBcColor:SetMouseVisible(false);
	self.ppbBcCp=DigitalUtopia.DUInterface.ColorPicker();
	self.ppbBcCp:SetParent(self.ppbBcHolder);
	self.ppbBcCp:SetPosition(305,5);
	self.ppbBcCp.doActive=function()
		self:Activate();
	end
	self.ppbBcOL=Turbine.UI.Control();
	self.ppbBcOL:SetParent(self.ppbBcColor);
	self.ppbBcOL:SetSize(30,20);
	self.ppbBcOL:SetZOrder(5);
	self.ppbBcOL:SetPosition(2,2);
	self.ppbBcOL:SetBackColor(Turbine.UI.Color(1,0,0));
	self.ppbBcOL:SetMouseVisible(false);
	self.colPanel:AddItem(self.ppbBcHolder);
	self.ppbBcCp.ColorChanged=function(sender,args)
		self.ppbBcOL:SetBackColor(args.Color);
		self.ppbBcChanged();
	end
	
	self.ppbTcHolder=Turbine.UI.Control();
	self.ppbTcHolder:SetSize(420,35);
	self.ppbTcHolder:SetMouseVisible(false);
	self.ppbTcLabel=Turbine.UI.Label();
	self.ppbTcLabel:SetParent(self.ppbTcHolder);
	self.ppbTcLabel:SetPosition(0,0);
	self.ppbTcLabel:SetSize(246,35);
	self.ppbTcLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.ppbTcLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ppbTcLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.ppbTcLabel:SetText(TEXT_COLOR);
	self.ppbTcLabel:SetMouseVisible(false);
	self.ppbTcColor=Turbine.UI.Lotro.TextBox();
	self.ppbTcColor:SetParent(self.ppbTcHolder);
	self.ppbTcColor:SetSize(35,25);
	self.ppbTcColor:SetPosition(265,5);
	self.ppbTcColor:SetReadOnly(true);
	self.ppbTcColor:SetMouseVisible(false);
	self.ppbTcCp=DigitalUtopia.DUInterface.ColorPicker();
	self.ppbTcCp:SetParent(self.ppbTcHolder);
	self.ppbTcCp:SetPosition(305,5);
	self.ppbTcCp.doActive=function()
		self:Activate();
	end
	self.ppbTcOL=Turbine.UI.Control();
	self.ppbTcOL:SetParent(self.ppbTcColor);
	self.ppbTcOL:SetSize(30,20);
	self.ppbTcOL:SetZOrder(5);
	self.ppbTcOL:SetPosition(2,2);
	self.ppbTcOL:SetBackColor(Turbine.UI.Color(1,0,0));
	self.ppbTcOL:SetMouseVisible(false);
	self.colPanel:AddItem(self.ppbTcHolder);
	self.ppbTcCp.ColorChanged=function(sender,args)
		self.ppbTcOL:SetBackColor(args.Color);
		self.ppbTcChanged();
	end
	
	
	
	
	
	self.ppbEceHolder=Turbine.UI.Control();
	self.ppbEceHolder:SetSize(420,30);
	self.ppbEceHolder:SetMouseVisible(false);
	self.ppbEce = DigitalUtopia.DUInterface.CheckBox(3);
	self.ppbEce:SetChecked(true);
	self.ppbEce:SetText(ENABLE_CE);
	self.ppbEce:SetParent(self.ppbEceHolder);
	self.ppbEce:SetLeft(55);
	self.ppbEce.doActive=function()
		self:Activate();
	end
	self.colPanel:AddItem(self.ppbEceHolder); 
	
	self.ppbEctHolder=Turbine.UI.Control();
	self.ppbEctHolder:SetSize(420,30);
	self.ppbEctHolder:SetMouseVisible(false);
	self.ppbEct = DigitalUtopia.DUInterface.CheckBox(3);
	self.ppbEct:SetChecked(true);
	self.ppbEct:SetText(ENABLE_CT);
	self.ppbEct:SetParent(self.ppbEctHolder);
	self.ppbEct:SetLeft(55);
	self.ppbEct.doActive=function()
		self:Activate();
	end
	self.colPanel:AddItem(self.ppbEctHolder); 
	
	self.ppbClrOneHolder=Turbine.UI.Control();
	self.ppbClrOneHolder:SetSize(420,35);
	self.ppbClrOneHolder:SetBackColor(Turbine.UI.Color(0.01,0,0,0));
	self.ppbClrOneHolder:SetMouseVisible(false);
	self.ppbClrOneLabel=Turbine.UI.Label();
	self.ppbClrOneLabel:SetParent(self.ppbClrOneHolder);
	self.ppbClrOneLabel:SetPosition(0,0);
	self.ppbClrOneLabel:SetSize(246,35);
	self.ppbClrOneLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.ppbClrOneLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ppbClrOneLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.ppbClrOneLabel:SetText(POINT_ONE_COLOR);
	self.ppbClrOneLabel:SetMouseVisible(false);
	self.ppbClrOneColor=Turbine.UI.Lotro.TextBox();
	self.ppbClrOneColor:SetParent(self.ppbClrOneHolder);
	self.ppbClrOneColor:SetSize(35,25);
	self.ppbClrOneColor:SetPosition(265,5);
	self.ppbClrOneColor:SetReadOnly(true);
	self.ppbClrOneColor:SetMouseVisible(false);
	self.ppbClrOneCp=DigitalUtopia.DUInterface.ColorPicker();
	self.ppbClrOneCp:SetParent(self.ppbClrOneHolder);
	self.ppbClrOneCp:SetPosition(305,5);
	self.ppbClrOneCp.doActive=function()
		self:Activate();
	end
	self.ppbClrOneOL=Turbine.UI.Control();
	self.ppbClrOneOL:SetParent(self.ppbClrOneColor);
	self.ppbClrOneOL:SetSize(30,20);
	self.ppbClrOneOL:SetZOrder(5);
	self.ppbClrOneOL:SetPosition(2,2);
	self.ppbClrOneOL:SetBackColor(Turbine.UI.Color(1,0,0));
	self.ppbClrOneOL:SetMouseVisible(false);
	self.colPanel:AddItem(self.ppbClrOneHolder);
	self.ppbClrOneCp.ColorChanged=function(sender,args)
		self.ppbClrOneOL:SetBackColor(args.Color);
		self.ppbClrOneChanged();
	end
	
	self.ppbCpOneHolder = Turbine.UI.Control();
	self.ppbCpOneHolder:SetSize(420,45);
	self.ppbCpOneHolder:SetBackColor(Turbine.UI.Color(0.01,0,0,0));
	self.ppbCpOneHolder:SetMouseVisible(false);
	self.ppbCpOneSld = DigitalUtopia.DUInterface.Slider();
	self.ppbCpOneSld:SetStep(0.01);
	self.ppbCpOneSld:SetParent(self.ppbCpOneHolder);
	self.ppbCpOneSld:SetLeft(57);
	self.ppbCpOneSld:SetText(POINT_ONE_LOC);
	self.ppbCpOneSld.doActive=function()
		self:Activate();
	end
	self.colPanel:AddItem(self.ppbCpOneHolder);
	
	self.ppbEscHolder=Turbine.UI.Control();
	self.ppbEscHolder:SetSize(420,30);
	self.ppbEscHolder:SetMouseVisible(false);
	self.ppbEsc = DigitalUtopia.DUInterface.CheckBox(3);
	self.ppbEsc:SetChecked(true);
	self.ppbEsc:SetText(ENABLE_SECOND);
	self.ppbEsc:SetParent(self.ppbEscHolder);
	self.ppbEsc:SetLeft(55);
	self.ppbEsc.doActive=function()
		self:Activate()
	end
	self.colPanel:AddItem(self.ppbEscHolder); 
	
	self.ppbClrTwoHolder=Turbine.UI.Control();
	self.ppbClrTwoHolder:SetSize(420,35);
	self.ppbClrTwoHolder:SetBackColor(Turbine.UI.Color(0.01,0,0,0));
	self.ppbClrTwoHolder:SetMouseVisible(false);
	self.ppbClrTwoLabel=Turbine.UI.Label();
	self.ppbClrTwoLabel:SetParent(self.ppbClrTwoHolder);
	self.ppbClrTwoLabel:SetPosition(0,0);
	self.ppbClrTwoLabel:SetSize(246,35);
	self.ppbClrTwoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.ppbClrTwoLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ppbClrTwoLabel:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.ppbClrTwoLabel:SetText(POINT_TWO_COLOR);
	self.ppbClrTwoLabel:SetMouseVisible(false);
	self.ppbClrTwoColor=Turbine.UI.Lotro.TextBox();
	self.ppbClrTwoColor:SetParent(self.ppbClrTwoHolder);
	self.ppbClrTwoColor:SetSize(35,25);
	self.ppbClrTwoColor:SetPosition(265,5);
	self.ppbClrTwoColor:SetReadOnly(true);
	self.ppbClrTwoColor:SetMouseVisible(false);
	self.ppbClrTwoCp=DigitalUtopia.DUInterface.ColorPicker();
	self.ppbClrTwoCp:SetParent(self.ppbClrTwoHolder);
	self.ppbClrTwoCp:SetPosition(305,5);
	self.ppbClrTwoCp.doActive=function()
		self:Activate();
	end
	self.ppbClrTwoOL=Turbine.UI.Control();
	self.ppbClrTwoOL:SetParent(self.ppbClrTwoColor);
	self.ppbClrTwoOL:SetSize(30,20);
	self.ppbClrTwoOL:SetZOrder(5);
	self.ppbClrTwoOL:SetPosition(2,2);
	self.ppbClrTwoOL:SetBackColor(Turbine.UI.Color(1,0,0));
	self.ppbClrTwoOL:SetMouseVisible(false);
	self.colPanel:AddItem(self.ppbClrTwoHolder);
	self.ppbClrTwoCp.ColorChanged=function(sender,args)
		self.ppbClrTwoOL:SetBackColor(args.Color);
		self.ppbClrTwoChanged();
	end
	
	self.ppbCpTwoHolder = Turbine.UI.Control();
	self.ppbCpTwoHolder:SetSize(420,45);
	self.ppbCpTwoHolder:SetBackColor(Turbine.UI.Color(0.01,0,0,0));
	self.ppbCpTwoHolder:SetMouseVisible(false);
	self.ppbCpTwoSld = DigitalUtopia.DUInterface.Slider();
	self.ppbCpTwoSld:SetStep(0.01);
	self.ppbCpTwoSld:SetParent(self.ppbCpTwoHolder);
	self.ppbCpTwoSld:SetLeft(57);
	self.ppbCpTwoSld:SetText(POINT_TWO_LOC);
	self.ppbCpTwoSld.doActive=function()
		self:Activate();
	end
	self.colPanel:AddItem(self.ppbCpTwoHolder);
	
	self.setupPanel=Turbine.UI.Window();
	self.setupPanel:SetVisible(true);
	self.setupPanel:SetParent(self);
	self.setupPanel:SetSize(140,507);
	self.setupPanel:SetBackground("DigitalUtopia/Palantir/Resources/Options_menu_side_bar.tga");
	self.setupPanel:SetPosition(self:GetWidth()-143,20);
	self.setupPanel:SetMouseVisible(false);
	self.alertHolder=Turbine.UI.Window();
	self.alertHolder:SetVisible(true);
	self.alertHolder:SetVisible(false);
	--self.alertHolder:SetMouseVisible(false);
	self.alertHolder:SetSize(Turbine.UI.Display:GetWidth(),Turbine.UI.Display:GetHeight());
	--self.alertHolder:SetBackColor(Turbine.UI.Color(.01,0,0,0));
	self.alertHolder:SetZOrder(200);
	self.alert=DigitalUtopia.DUInterface.BaseWindow(512,172);
	self.alert:SetParent(self.alertHolder);
	self.alert:SetPosition((Turbine.UI.Display:GetWidth()-self.alert:GetWidth())/2,(Turbine.UI.Display:GetHeight()-self.alert:GetHeight())/2);
	self.alert:SetZOrder(99);
	self.alertText=Turbine.UI.Label();
	self.alertText:SetParent(self.alert);
	self.alertText:SetSize(512,20);
	self.alertText:SetForeColor(Turbine.UI.Color(210/255,255/255,0/255));
	self.alertText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.alertText:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.alertText:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.alertText:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	self.alertText:SetText(" "..ARE_YOU_SURE);
	self.alertText:SetPosition(0,54);
	self.alertYes=Turbine.UI.Lotro.Button();
	self.alertYes:SetParent(self.alert);
	self.alertYes:SetText(YES);
	self.alertYes:SetSize(106,20);
	self.alertYes:SetPosition(144,141);
	self.alertNo=Turbine.UI.Lotro.Button();
	self.alertNo:SetParent(self.alert);
	self.alertNo:SetText(NO);
	self.alertNo:SetSize(106,20);
	self.alertNo:SetPosition(263,141);
	self.nocPanel.MouseClick=function(sender,args)
		self.noc.Close();
		self.nocPanel:SetVisible(false);
	end


	self.noc.Opening =function()
		self.nocPanel:SetVisible(true);
		tl,tt=self.nocHolder:PointToScreen(self.nocHolder:GetPosition());
		self.nocLb:SetPosition(246,self.nocHolder:GetTop()+21);
		
	end
	
		self.acPanel.MouseClick=function(sender,args)
		self.ac.Close();
		self.acPanel:SetVisible(false);
	end


	self.ac.Opening =function()
		self.acPanel:SetVisible(true);
		tl,tt=self.acHolder:PointToScreen(self.acHolder:GetPosition());
		self.acLb:SetPosition(246,self.acHolder:GetTop()+21);
		
	end
	
	self.gen = ToggleButton();
	self.gen:SetParent(self.setupPanel);
	self.gen:SetPosition(7,100);
	self.gen.SetToggle(1);
	self.gen.SetText(MAIN);
	self.gen.doActive=function()
		self:Activate();
	end

	
	self.col = ToggleButton();
	self.col:SetParent(self.setupPanel);
	self.col:SetPosition(7,125);
	self.col.SetText(COLOR);	
	self.col.doActive=function()
		self:Activate();
	end


	self.txt = ToggleButton();
	self.txt:SetParent(self.setupPanel);
	self.txt:SetPosition(7,150);
	self.txt.SetText(TEXT);
	
	self.txt.doActive=function()
		self:Activate();
	end

	self.gen.Click=function()
		self.tw:SetVisible(true);
		self.col.SetToggle(0);
		self.clw:SetVisible(false);
		self.txt.SetToggle(0);
		self.txw:SetVisible(false);
	end
	
	self.col.Click=function()
		self.clw:SetVisible(true);
		self.gen.SetToggle(0);
		self.tw:SetVisible(false);
		self.txt.SetToggle(0);
		self.txw:SetVisible(false);
	end
	
	self.txt.Click=function()
		self.txw:SetVisible(true);
		self.gen.SetToggle(0);
		self.tw:SetVisible(false);
		self.col.SetToggle(0);
		self.clw:SetVisible(false);
	end
	
	
	self.showSetup = function()
		
	end
	
	self.closeSetup = function()
	
	end
	

end