--[[***NewButton***
	 Create a new button
	Example use; MyButton = NewButton{x=5,y=10,width=30,height=30,parent=TestWindow} NOTE THE CURLY BRACKETS!
	 Options;
				x,y coordinates		Mandatory
				width,height			Mandatory
				opacity					Default to 1
				colour						Default to red
				image						Default to none Note: Colour and image are mutally exclusive.
				parent						MUST HAVE A PARENT!
				visible						Default to true
				rightclick,leftclick	runs this FUNCTION if it is non null. Pass in the format "function () *function you want to run* end"]]--
	NewButton = class( Turbine.UI.Button )		  
	function NewButton:Constructor(options)
		Turbine.UI.Button.Constructor( self );
			self :SetPosition			( options.x,options.y)
			self :SetSize				( options.width,options.height )
			if options.visible~=nil then 	self :SetVisible ( options.visible ) else self :SetVisible ( true ) end
			self :SetOpacity			( options.opacity or 1 )
			self :SetParent			( options.parent )
			if options.parent==nil then echo ("BUTTONS MUST HAVE A PARENT") end
			if options.image ~=nil then 	self :SetBackground ( options.image) else self :SetBackColor ( options.colour or Turbine.UI.Color( 1, 0, 0)) end
			if options.rightclick ~=nil then
			function self:MouseDown( args )
				if ( args.Button == Turbine.UI.MouseButton.Right ) then
					options.rightclick()
				 end
			end
			end
			if options.leftclick ~=nil then
				function self:MouseDown( args )
					if ( args.Button == Turbine.UI.MouseButton.Left ) then
						options.leftclick()
					 end
				end
			end
			if(((options.rightclick ~=nil) and (options.leftclick ~=nil))==true) then
				function self:MouseDown( args )
					if ( args.Button == Turbine.UI.MouseButton.Left ) then
						options.leftclick()
					elseif ( args.Button == Turbine.UI.MouseButton.Right ) then
					options.rightclick()
					end
				 end
			end
	end