import "Turbine.UI.Lotro";

--[[***NewQuickslot***
	 Create a new quickslot
	 Example use; MyQuickslot = NewQuickslot {x=10,y=10,parent=mywindow} NOTE THE CURLY BRACKETS!
	 Options;
		 x,y coordinates	Default to 0
		 visible				Default to 1
		 opacity				Default to 1
		 parent					Mandatory
		 size					LEAVE FOR NOW -- Turbine do not allow us to change the size yet]]--
	NewQuickslot=class (Turbine.UI.Lotro.Quickslot)
	function NewQuickslot:Constructor (options)
		Turbine.UI.Lotro.Quickslot.Constructor(self);
		self :SetPosition			( options.x or 0,options.y or 0)
		self :SetVisible			( options.visible or 1 )
		self :SetOpacity			( options.opacity or 1 )
		self:SetParent				( options.parent );
		self:SetSize				(options.size or 35,options.size or 35);

		--[[Original Right swopping code!

		--This does not work if external slots are involved.
		To recreate the bug;
		Drag an icon out of the bar. Call this slot1
		Drag an icon from a turbine slot(such as the skill panel) into a different slot. Slot1 will change, even though it shouldn't.

		self.MouseDown = function(sender,args)
			--Set two global variables when we begin to drag a quickslot.
				shortcutfrom=self								--This is where the shortcut is coming FROM	
				draggingShortcut=false						--The shortcut is NOT being dragged around, only clicked.
		end

		self.DragEnter = function(sender,args)
			draggingShortcut = true;						--We *are* dragging a shortcut, because we entered another quicklsot.
			targetshortcut=self:GetShortcut()		--If we enter a quickslot then store it's shortcut ready for a swop operation.
		end
		
		self.ShortcutChanged=function(sender,args)
			--If we are dragging a shortcut, and this shortcut changes then set the source with the destination. I.E. a swop!
				if draggingShortcut then
					if shortcutfrom ~=nil then
						--Here - if the target shortcut is empty then DO NOT copy the shortcut - sadly this will mean the "copy slot" behaviour will be back - but it should stop that bug.
						
						--**INSERT CODE HERE!
						--First I need to know if an empty shortcut is "nil" or what...
						
						shortcutfrom:SetShortcut(targetshortcut)
						targetshortcut=nil; shortcutfrom=nil; draggingShortcut=false
					end
				end
		end
		
		self.DragDrop= function(sender,args)
			--echo("Never fires - when it does it is time to fix the drag behaviour with a much simpler solution!")
		end]]--
		--[[
		DEV NOTES!
		self.MouseDown = function(sender,args)
			echo "Mouse down"
			--Fires when a slot is clicked
			dragging=false
		end
		self.MouseUp = function(sender,args)
			echo "Mouse up"
			--Fires when a slot is clicked
			--OR
			--On dragleave - but only for the very FIRST slot.
			--However - sometimes even fires when you don't leave the slot!
		end
		self.MouseLeave = function(sender,args)
			echo "Mouse leave"
			--Fires whenever you leave a quickslot. Dragging or not - just fires.
		end
		self.DragEnter = function(sender,args)
			echo "Drag Enter"
			--Fires whenever entering a slot and dragging
			--dragging=true --We are dragging SOMETHING, not nessecerily one of my quickslots.
		end
		self.DragLeave = function(sender,args)
			echo "Drag Leave"
			--Fires whenever leaving a slot and dragging
			if not(dragging) then
				source=self
				self:SetShortcut(nil)
			end
			dragging=true
		end
		self.ShortcutChanged=function(sender,args)
			--Fires when a quickslot is changed
			echo "Changed"
		end
		self.DragDrop= function(sender,args)
			--Never fires - when it does it is time to fix the drag behaviour.
			echo("Drag Drop")			
		end]]--
		
		
		--Stolen from PagedSlots by D1Hicks
					--Allows the default Turbine 'drag and drop' behaviour
					--Without this slots dragged around leave copies of abilities behind.
							self.MouseDown = function(sender,args)
								self.draggingShortcut = true;
							end

							self.MouseLeave = function(sender,args)
								if(self.draggingShortcut) then
									--Turbine.Shell.WriteLine("I'm Out!");
									self.draggedOut = true;
								end
							end

							self.MouseUp = function(sender,args)
								if(args.Button == Turbine.UI.MouseButton.Left) then
									if(self.draggedOut) then
										--Turbine.Shell.WriteLine("I'm Up");
										self:SetShortcut();
									end
								end
								self.draggedOut=false;
								self.draggingShortcut = false;
							end
					--End of D1Hicks code

		
	end	