import "Turbine"
import "Turbine.UI";
import "Turbine.Utils";

 --[[***NewWindow***
	 Create a new window
	Example use; MyWindow = NewWindow{x=5.y=10.width=30,height=30} NOTE THE CURLY BRACKETS!
	 Options;
				x,y coordinates		Mandatory
				width,height			Mandatory
				opacity					Default to 1
				colour						Default to red	Note: Colour and image are mutally exclusive.
				parent						Default to none
				image						Default to none
				mousevisible			Default to 1]]--
	NewWindow = class( Turbine.UI.Window )
	function NewWindow:Constructor(options)
		Turbine.UI.Window.Constructor( self )
		self :SetPosition			( options.x,options.y)
		self :SetSize				( options.width,options.height )
		
		self :SetVisible			( options.visible or 1 )
		self :SetOpacity			( options.opacity or 1 )
		self :SetParent			( options.parent or nil)
		if options.mousevisible ~=nil then self :SetMouseVisible	( options.mousevisible) end
		if options.image ~=nil then 	self :SetBackground ( options.image) else self :SetBackColor ( options.colour or Turbine.UI.Color( 1, 0, 0)) end
	end