import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "Turbine.Utils";
import "KragenPlugs.KragenBars";

BurgBars = class(  );

function BurgBars:Constructor()

    -- inialize the setupWindow
	self.setup = SetupWindow();

	-- class settings arnt saved then load the default settings
	if (not settings.class) then
	    settings.class = "Burglar";
	    self:DefaultSettings();
	    self:ShowSetup();
	else
		self.settings = settings.classinfo;
	end
    
    self.window = { };
    
    -- CRIT RESPONSE WINDOW
    self.window[1] = Window("CRIT", 3, 2, -1.5, 0, self.settings.crit);

		-- Crit Stage 1
		self.window[1]:AddBar(1, 1, 1, 0, 0, false, true);
		self.window[1].bar[1]:AddQuickSlot(1, 1, 1, "0x70003F0B"); -- Burglar's Advantage
		self.window[1].bar[1]:SetZOrder(5);
		
		-- Crit Stage 2
		self.window[1]:AddBar(2, 1, 1, 0, 0, false, true);
		self.window[1].bar[2]:AddQuickSlot(1, 1, 1, "0x70003F0C"); -- Double Edged Strike
		self.window[1].bar[2]:SetZOrder(5);


		-- Crit Stage 3
		self.window[1]:AddBar(3, 3, 2, 0, 0, false, false);
		self.window[1].bar[3]:AddQuickSlot(1, 2, 1, "0x70000F80"); -- Exposed Throat
		self.window[1].bar[3]:AddQuickSlot(2, 3, 1, "0x70000F5D"); -- Flashing Blades
		
		self.window[1].bar[3]:AddQuickSlot(3, 1, 2, "0x7000FB71"); -- Feint Attack
		self.window[1].bar[3]:AddQuickSlot(4, 2, 2, "0x7000FD86"); -- Lucky Strike
		self.window[1].bar[3]:AddQuickSlot(5, 3, 2, "0x7000FB73"); -- Small Snag
		
    -- MISCHIEF WINDOW
    self.window[2] = Window("MISCHIEF", 1, 1, 2.5, 1, self.settings.mischief);

		-- Mischief
		self.window[2]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[2].bar[1]:AddQuickSlot(1, 1, 1, "0x7000D4A4"); -- Mischief
		
    -- FIND FOOTING WINDOW
    self.window[3] = Window("STUN", 1, 1, 2.5, 0, self.settings.footing);

		-- Find Footing
		self.window[3]:AddBar(1, 1, 1, 0, 0, false, false);
		self.window[3].bar[1]:AddQuickSlot(1, 1, 1, "0x70003F14"); -- Find Footing
		
    -- FM RESPONSE WINDOW
    self.window[4] = Window("FM", 1, 2, -3.5, 0, self.settings.fellowship);

		-- Fellowship Response
		self.window[4]:AddBar(1, 1, 2, 0, 0, false, false);
		self.window[4].bar[1]:AddQuickSlot(1, 1, 1, "0x7000D443"); -- Escape Clause
		self.window[4].bar[1]:AddQuickSlot(2, 1, 2, "0x7000D447"); -- Seize Initiative
		
	-- SET WINDOW OPACITY
	self.window[1]:SetOpacity(settings.opacity);
	self.window[2]:SetOpacity(settings.opacity);
	self.window[3]:SetOpacity(settings.opacity);
	self.window[4]:SetOpacity(settings.opacity);
	
	
	-- SET WINDOW VISIBILITY
	self.window[1]:SetVisible(self.settings.crit.active);
	self.window[2]:SetVisible(self.settings.mischief.active);
	self.window[3]:SetVisible(self.settings.footing.active);
	self.window[4]:SetVisible(self.settings.fellowship.active);
	
	-- Hook into the player to receive updates about player morale and
	-- power.
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		self.player = Turbine.Gameplay.LocalPlayer.GetInstance();
	else
		self.player = Turbine.Gameplay.LocalPlayer();
	end
	
	local effects = self.player:GetEffects();

	effects.EffectAdded = function( sender, args )
		self:AddEffect( args.Index );
	end

	effects.EffectRemoved = function( sender, args )
		self:RemoveEffect( args.Effect );
	end
	
	self.player.InCombatChanged = function( sender, args )
      	if (self.player:IsInCombat() == false) then
			if (self.settings.mischief.active) then
			    self.window[2].bar[1]:SetVisible( true );
			end
		elseif (self.player:IsInCombat() == true ) then
            if (self.settings.mischief.active) then
			    self.window[2].bar[1]:SetVisible( false );
			end
		end
	end
end


function BurgBars:AddEffect( effectIndex )
	local addedeffect = self.player:GetEffects():Get( effectIndex );

	-- Crit Response
	if (addedeffect:GetName() == "Critical Response") then
        self.window[1]:BarActive(1 , addedeffect:GetID(), true, true);

	-- Double Edged
	elseif (addedeffect:GetName() == "Double Edged") then
	    if (self.window[2].bar[1].effectID ~= 0) then
	        self.window[1].bar[3].slot[3]:SetVisible( false );
		else
            self.window[1].bar[3].slot[3]:SetVisible( self.settings.crit.capstones );
		end
	    self.window[1]:BarActive(2 , 0, false, false);
        self.window[1]:BarActive(3 , addedeffect:GetID(), true, true);

	-- Mischief / Stealth
	elseif (addedeffect:GetName() == "Mischievous") then
  		self.window[2]:BarActive(1 , addedeffect:GetID(), true, true);
		if (self.settings.mischief.disappear) then
			self.window[2].bar[1]:SetVisible( false );
		else
			self.window[2].bar[1]:SetHover( true );
		end


	-- Stunned, Dazed, Knocked Down
	elseif (addedeffect:GetName() == "Stunned" or addedeffect:GetName() == "Dazed" or addedeffect:GetName() == "Knocked Down") then
  		self.window[3]:BarActive(1 , addedeffect:GetID(), true, true);
    
    -- Fellowship Manoeuvre Response
	elseif (addedeffect:GetName() == "Fellowship Manoeuvre Response") then
  		self.window[4]:BarActive(1 , addedeffect:GetID(), true, true);
  
    end
end

function BurgBars:RemoveEffect( effect )

	-- Crit Response
	if (effect:GetName() == "Critical Response") then
  		self.window[1]:BarActive(1 , effect:GetID(), false, false);
  		if (self.window[1].bar[1].effectID == 0) then
    		self.window[1]:BarActive(2 , effect:GetID(), true, true);
    		self.window[1].bar[2]:StartTimer(5, false);
		end


	-- Double Edged
	elseif (effect:GetName() == "Double Edged") then
  		self.window[1]:BarActive(3 , effect:GetID(), false, false);


	-- Mischief / Stealth
	elseif (effect:GetName() == "Mischievous") then
  		self.window[2]:BarActive(1 , effect:GetID(), false, false);
  		if (self.window[2].bar[1].effectID == 0) then
			self.window[2].bar[1]:SetHover( false );
  		    self.window[1].bar[3].slot[3]:SetVisible( self.settings.crit.capstones );
		end
		if (self.player:IsInCombat() == false) then
			self.window[2].bar[1]:SetVisible(true);
		end


	-- Stunned, Dazed or Knocked Down
	elseif ((effect:GetName() == "Stunned" or effect:GetName() == "Dazed" or effect:GetName() == "Knocked Down")) then
        self.window[3]:BarActive(1 , effect:GetID(), false, false);
			
    -- Fellowship Manoeuvre Response
	elseif (effect:GetName() == "Fellowship Manoeuvre Response") then
        self.window[4]:BarActive(1 , effect:GetID(), false, false);


	end
end

function BurgBars:DefaultSettings()
	self.settings = { };

	self.settings.crit = { };
	self.settings.crit.active = true;
	self.settings.crit.x = 0;
	self.settings.crit.y = 0;
	self.settings.crit.exposed = true;
	self.settings.crit.flashing = true;
	self.settings.crit.capstones = true;

	self.settings.mischief = { };
	self.settings.mischief.active = true;
	self.settings.mischief.x = 0;
	self.settings.mischief.y = 0;
	self.settings.mischief.disappear = false;

	self.settings.footing = { };
	self.settings.footing.active = true;
	self.settings.footing.x = 0;
	self.settings.footing.y = 0;
	self.settings.footing.timer = true;

	self.settings.fellowship = { };
	self.settings.fellowship.active = true;
	self.settings.fellowship.x = 0;
	self.settings.fellowship.y = 0;
end

function BurgBars:SaveSettings()
	self.settings.crit.x, self.settings.crit.y = self.window[1]:GetPosition();
	self.settings.mischief.x, self.settings.mischief.y = self.window[2]:GetPosition();
	self.settings.footing.x, self.settings.footing.y = self.window[3]:GetPosition();
	self.settings.fellowship.x, self.settings.fellowship.y = self.window[4]:GetPosition();
	settings.classinfo = self.settings;
	SaveSettings();
end

function BurgBars:ShowSetup()
	self.setup:SetVisible(true);
	self.setup.slider1:SetValue(settings.opacity);
	
	self.setup.checkbox1:SetText("Crit Chain");
	self.setup.checkbox2:SetText("Mischief");
	self.setup.checkbox3:SetText("Find Footing");
  	self.setup.checkbox4:SetText("FM Reactives");
  	self.setup.checkbox5:SetText("Exposed Throat");
  	self.setup.checkbox6:SetText("Flashing Blades");
  	self.setup.checkbox7:SetText("Capstones");
    self.setup.checkbox8:SetVisible(false);
    self.setup.checkbox9:SetVisible(false);
    self.setup.checkbox10:SetText("Mischief Disappear")
    self.setup.checkbox11:SetVisible(false);
  	self.setup.checkbox1:SetChecked( self.settings.crit.active );
  	self.setup.checkbox2:SetChecked( self.settings.mischief.active );
  	self.setup.checkbox3:SetChecked( self.settings.footing.active );
  	self.setup.checkbox4:SetChecked( self.settings.fellowship.active );
  	self.setup.checkbox5:SetChecked( self.settings.crit.exposed );
  	self.setup.checkbox6:SetChecked( self.settings.crit.flashing );
  	self.setup.checkbox7:SetChecked( self.settings.crit.capstones );
  	self.setup.checkbox10:SetChecked( self.settings.mischief.disappear );
    self.setup.psTitle:SetVisible( false );
    self.setup.ssTitle:SetVisible( false );
	self.setup:SetText("KB: Burglar");
end

function BurgBars:SetupClosing()
    self.settings.crit.active = self.setup.checkbox1:GetChecked();
	self.settings.mischief.active = self.setup.checkbox2:GetChecked();
	self.settings.footing.active = self.setup.checkbox3:GetChecked();
	self.settings.fellowship.active = self.setup.checkbox4:GetChecked();
	self.settings.crit.exposed = self.setup.checkbox5:GetChecked();
	self.settings.crit.flashing = self.setup.checkbox6:GetChecked();
	self.settings.crit.capstones = self.setup.checkbox7:GetChecked();
	self.settings.mischief.disappear = self.setup.checkbox10:GetChecked();
	
	if (not self.settings.mischief.disappear) then
  		if (not self.player:IsInCombat()) then
  		    self.window[2].bar[1]:SetVisible( true );
			if (self.window[2].bar[1].effectID ~= 0) then
			    self.window[2].bar[1]:SetHover( true );
	        else
                self.window[2].bar[1]:SetHover( false );
			end
  		end
	else
	    if (self.window[2].bar[1].effectID ~= 0) then
			self.window[2].bar[1]:SetVisible( false );
		end
	end
	
	if (self.player:IsInCombat()) then
		self.window[2].bar[1]:SetVisible( false );
	end

	self.window[1].bar[3].slot[1]:SetVisible( self.settings.crit.exposed );
	self.window[1].bar[3].slot[2]:SetVisible( self.settings.crit.flashing );
	self.window[1].bar[3].slot[3]:SetVisible( self.settings.crit.capstones );
	self.window[1].bar[3].slot[4]:SetVisible( self.settings.crit.capstones );
	self.window[1].bar[3].slot[5]:SetVisible( self.settings.crit.capstones );
	self.window[1]:SetVisible(false);
	self.window[1]:SetVisible(true);
	
	self.window[1].display(self.settings.crit.active);
	self.window[2].display(self.settings.mischief.active);
	self.window[3].display(self.settings.footing.active);
	self.window[4].display(self.settings.fellowship.active);

	-- SET WINDOW OPACITY
	self.window[1]:SetOpacity(settings.opacity);
	self.window[2]:SetOpacity(settings.opacity);
	self.window[3]:SetOpacity(settings.opacity);
	self.window[4]:SetOpacity(settings.opacity);

	self:SaveSettings();
end