import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "Turbine.Utils";
import "KragenPlugs.KragenBars";

GuardBars = class( );

function GuardBars:Constructor()

    -- inialize the setupWindow
	self.setup = SetupWindow();

	-- class settings arnt saved then load the default settings
	if (not settings.class) then
	    settings.class = "Guardian";
	    self:DefaultSettings();
	    self:ShowSetup();
	else
		self.settings = settings.classinfo;
	end
    
    self.window = { };
    
    -- BLOCK WINDOW
    self.window[1] = Window("BLOCK", 3, 1, -1.5, 0, self.settings.block);
    self.window[1]:SetZOrder(5);
    
		-- Block Reactive Stage 1
		self.window[1]:AddBar(1, 3, 1, 0, 0, false, true);
		self.window[1].bar[1]:AddQuickSlot(1, 1, 1, "0x7000305D"); -- Shield Swipe
		self.window[1].bar[1]:AddQuickSlot(2, 2, 1, "0x7000F095"); -- Litany of Defiance
		self.window[1].bar[1]:AddQuickSlot(3, 3, 1, "0x7000307D"); -- Catch a Breath


		-- Block Reactive Stage 2
		self.window[1]:AddBar(2, 3, 1, 0, 0, false, true);
		self.window[1].bar[2]:AddQuickSlot(1, 1.5, 1, "0x70003EE1"); -- Shield Bash
		self.window[1].bar[2]:AddQuickSlot(2, 2.5, 1, "0x70003EE6"); -- Shield Taunt


	-- PARRY WINDOW
    self.window[2] = Window("PARRY", 3, 2, -1.5, 1, self.settings.parry );


		-- Parry Reactive Stage 1
		self.window[2]:AddBar(1, 3, 1, 0, 0, false, true);
		self.window[2].bar[1]:AddQuickSlot(1, 2, 1, "0x70003EE0"); -- Retaliation
		
		-- Parry Reactive Stage 2
		self.window[2]:AddBar(2, 3, 1, 0, 0, false, true);
		self.window[2].bar[2]:AddQuickSlot(1, 1, 1, "0x70003EE2"); -- Overwhelm
		self.window[2].bar[2]:AddQuickSlot(2, 2, 1, "0x70003EE5"); -- Thrust
		self.window[2].bar[2]:AddQuickSlot(3, 3, 1, "0x70003EE4"); -- Whirling Retaliation
	
	
	-- WARD WINDOW
	self.window[3] = Window("WARD", 1, 1, 2.5, 1, self.settings.ward );
    
    
		-- Guardian's Ward
		self.window[3]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[3].bar[1]:AddQuickSlot(1, 1, 1, "0x70003066"); -- Guardian's Ward
		

    -- TTT WINDOW
	self.window[4] = Window("STUN", 1, 1, 2.5, 0, self.settings.tables );


		-- Turn the Tables Indicator
		self.window[4]:AddBar(1, 1, 1, 0, 0, false, false);
		self.window[4].bar[1]:AddQuickSlot(1, 1, 1, "0x70003EE8"); -- Turn The Tables
		

		
    -- OVERPOWER WINDOW
	self.window[5] = Window("OVERPOWER", 3, 1, -1.5, 0, self.settings.overpower);
	self.window[5]:SetZOrder(0);


		-- OVERPOWER WINDOW
		self.window[5]:AddBar(1, 3, 1, 0, 0, false, false);
  		self.window[5].bar[1]:AddQuickSlot(1, 1, 1, "0x7000D4B0"); -- Force Opening
		self.window[5].bar[1]:AddQuickSlot(2, 2, 1, "0x7000D4B3"); -- Stagger
		self.window[5].bar[1]:AddQuickSlot(3, 3, 1, "0x7000F158"); -- Brutal Assault
		
		
		
    -- STANCE WINDOW
	self.window[6] = Window("STANCE", 1, 1, 3.5, 1, self.settings.stance);


		-- Stance Indicator
		self.window[6]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[6].bar[1]:AddQuickSlot(1, 1, 1, ""); -- PrimaryStance
        self.window[6].bar[1].slot[1]:MultiShortcut(6, "0x70003EDF");
		self.window[6].bar[1].slot[1]:MultiShortcut(6, "0x70003EE3");
		self.window[6].bar[1].slot[1]:MultiShortcut(6, "0x7000D4B1");
		self.window[6].bar[1].slot[1]:MultiShortcut(6, "0x70002ED4");
		self.window[6].bar[1].slot[1]:SetScroll(true);
		self.window[6].bar[1].slot[1]:SetMulti(self.settings.stance.primary);
  		if (self.settings.stance.threat) then
			self.window[6].bar[1].slot[1]:ChangeTotal(4);
		else
	    	self.window[6].bar[1].slot[1]:ChangeTotal(3);
		end




    
	-- SET WINDOW OPACITY
	self.window[1]:SetOpacity(settings.opacity);
	self.window[2]:SetOpacity(settings.opacity);
	self.window[3]:SetOpacity(settings.opacity);
	self.window[4]:SetOpacity(settings.opacity);
	self.window[5]:SetOpacity(settings.opacity);
	self.window[6]:SetOpacity(settings.opacity);
	
	
	-- SET WINDOW VISIBILITY
	self.window[1]:SetVisible(self.settings.block.active);
	self.window[2]:SetVisible(self.settings.parry.active);
	self.window[3]:SetVisible(self.settings.ward.active);
	self.window[4]:SetVisible(self.settings.tables.active);
	self.window[5]:SetVisible(self.settings.overpower.active);
	self.window[6]:SetVisible(self.settings.stance.active);


	

	-- Hook into the player to receive updates about player morale and
	-- power.
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		player = Turbine.Gameplay.LocalPlayer.GetInstance();
	else
		player = Turbine.Gameplay.LocalPlayer();
	end

	local effects = self.player:GetEffects();

	-- triggers add effect function when new buff/debuffs are added
	effects.EffectAdded = function( sender, args )
		self:AddEffect( args.Index );
	end

    -- triggers remove effect function when new buff/debuffs are removed
	effects.EffectRemoved = function( sender, args )
		self:RemoveEffect( args.Effect );
	end
end


function GuardBars:AddEffect( effectIndex )
	local addedeffect = self.player:GetEffects():Get( effectIndex );
	
 	-- Block Response
	if (addedeffect:GetName() == "Block Response") then
		self.window[1]:BarActive(1 , addedeffect:GetID(), true, true);

	-- Shield Swipe
	elseif (addedeffect:GetName() == "Shield Swipe") then
  		self.window[1]:BarActive(2 , addedeffect:GetID(), true, true);

	-- Parry Response
	elseif (addedeffect:GetName() == "Parry Response") then
  		self.window[2]:BarActive(1 , addedeffect:GetID(), true, true);

	-- Retaliation
	elseif (addedeffect:GetName() == "Retaliation") then
        self.window[2]:BarActive(2 , addedeffect:GetID(), true, true);

	-- Guardian's Ward
	elseif ((addedeffect:GetName() == "Guardian's Ward" or addedeffect:GetName() == "Improved Guardian's Ward")) then
		self.window[3]:BarActive(1, addedeffect:GetID(), true, false);
		
		if (self.settings.ward.timer) then
			self.window[3].bar[1]:StartTimer(addedeffect:GetDuration() * .70, true);
		end


	-- Stunned, Dazed, Knocked Down
	elseif (addedeffect:GetName() == "Stunned" or addedeffect:GetName() == "Dazed" or addedeffect:GetName() == "Knocked Down") then
    	self.window[4]:BarActive(1 , addedeffect:GetID(), true, true);
		
	-- Stance Change
	elseif (addedeffect:GetName() == "Guardian's Block Stance" or addedeffect:GetName() == "Guardian's Parry Stance" or addedeffect:GetName() == "Overpower" or addedeffect:GetName() == "Guardian's Threat Stance") then
    	self.window[6]:BarActive(1, addedeffect:GetID(), true, true);
		self.window[6].bar[1]:SetHover( true );
		
		if (addedeffect:GetName() == "Guardian's Block Stance") then
			self.settings.stance.current = 1;
		elseif (addedeffect:GetName() == "Guardian's Parry Stance") then
			self.settings.stance.current = 2;
		elseif (addedeffect:GetName() == "Overpower") then
			self.window[5]:BarActive(1, addedeffect:GetID(), true, true);
			self.window[5]:SetZOrder( 10 );
			self.settings.stance.current = 3;
		elseif (addedeffect:GetName() == "Guardian's Threat Stance") then
			self.settings.stance.current = 4;
		end
		
		if (self.settings.stance.current ~= self.settings.stance.primary) then
			self.window[6].bar[1].slot[1]:SetMulti(self.settings.stance.primary);
		else
			self.window[6].bar[1].slot[1]:SetMulti(self.settings.stance.secondary);
		end
		
    end
end

function GuardBars:RemoveEffect( effect )

	-- Block Response
	if (effect:GetName() == "Block Response") then
    	self.window[1]:BarActive(1 , effect:GetID(), false, false);


	-- Shield Swipe
	elseif (effect:GetName() == "Shield Swipe") then
    	self.window[1]:BarActive(2 , effect:GetID(), false, false);


	-- Parry Response
	elseif (effect:GetName() == "Parry Response") then
		self.window[2]:BarActive(1 , effect:GetID(), false, false);


	-- Retaliation
	elseif (effect:GetName() == "Retaliation") then
   		self.window[2]:BarActive(2 , effect:GetID(), false, false);


	-- Guardian's Ward
	elseif (effect:GetName() == "Guardian's Ward" or effect:GetName() == "Improved Guardian's Ward") then
  		self.window[3]:BarActive(1 , effect:GetID(), false, true);


	-- Stunned, Dazed or Knocked Down
	elseif (effect:GetName() == "Stunned" or effect:GetName() == "Dazed" or effect:GetName() == "Knocked Down") then
    	self.window[4]:BarActive(1 , effect:GetID(), false, false);
		
    -- Stance Change
 	elseif (effect:GetName() == "Guardian's Block Stance" or effect:GetName() == "Guardian's Parry Stance" or effect:GetName() == "Overpower" or effect:GetName() == "Guardian's Threat Stance") then
    	self.window[6]:BarActive(1, effect:GetID(), false, true);
    	if (self.window[6].bar[1].effectID == 0) then
			self.window[6].bar[1]:SetHover( false );
			self.window[6].bar[1].slot[1]:SetMulti(self.settings.stance.primary);
		end
		
		if ( effect:GetName() == "Overpower" ) then
			self.window[5]:BarActive(1, effect:GetID(), false, false);
    		self.window[5]:SetZOrder( 0 );
    	end


	end
end

-- default settings
function GuardBars:DefaultSettings()
	self.settings = { };
	
	self.settings.block = { };
	self.settings.block.active = true;
	self.settings.block.x = 0;
	self.settings.block.y = 0;
	
	self.settings.parry = { };
	self.settings.parry.active = true;
	self.settings.parry.x = 0;
	self.settings.parry.y = 0;
	
	self.settings.ward = { };
	self.settings.ward.active = true;
	self.settings.ward.x = 0;
	self.settings.ward.y = 0;
	self.settings.ward.timer = true;
	
	self.settings.tables = { };
	self.settings.tables.active = true;
	self.settings.tables.x = 0;
	self.settings.tables.y = 0;
	
	self.settings.overpower = { };
	self.settings.overpower.active = true;
	self.settings.overpower.x = 0;
	self.settings.overpower.y = 0;
	
	self.settings.stance = { };
	self.settings.stance.active = true;
	self.settings.stance.x = 0;
	self.settings.stance.y = 0;
	self.settings.stance.current = 1;
	self.settings.stance.primary = 1;
	self.settings.stance.secondary = 3;
	self.settings.stance.threat = true;
end

-- capture positions of windows and save settings.
function GuardBars:SaveSettings()
	self.settings.block.x, self.settings.block.y = self.window[1]:GetPosition();
	self.settings.parry.x, self.settings.parry.y = self.window[2]:GetPosition();
	self.settings.ward.x, self.settings.ward.y = self.window[3]:GetPosition();
	self.settings.tables.x, self.settings.tables.y = self.window[4]:GetPosition();
	self.settings.overpower.x, self.settings.overpower.y = self.window[5]:GetPosition();
	self.settings.stance.x, self.settings.stance.y = self.window[6]:GetPosition();
	settings.classinfo = self.settings;
	SaveSettings();
end

-- set and diaplay the setupwindow
function GuardBars:ShowSetup()
    self.setup:SetVisible(true);
	self.setup.slider1:SetValue(settings.opacity);

	self.setup.checkbox1:SetText("Block Chain");
	self.setup.checkbox2:SetText("Parry Chain");
	self.setup.checkbox3:SetText("Guardian's Ward");
  	self.setup.checkbox4:SetText("Turn The Tables");
    self.setup.checkbox5:SetText("Overpower Bar");
    self.setup.checkbox6:SetText("Stance Slot");
    self.setup.checkbox7:SetText("Threat Stance");
    self.setup.checkbox8:SetVisible(false);
    self.setup.checkbox9:SetVisible(false);
    self.setup.checkbox10:SetVisible(false);
    self.setup.checkbox11:SetText("Early Warning");
    
    self.setup.checkbox1:SetChecked( self.settings.block.active );
  	self.setup.checkbox2:SetChecked( self.settings.parry.active );
  	self.setup.checkbox3:SetChecked( self.settings.ward.active );
  	self.setup.checkbox4:SetChecked( self.settings.tables.active );
  	self.setup.checkbox5:SetChecked( self.settings.overpower.active );
  	self.setup.checkbox6:SetChecked( self.settings.stance.active );
  	self.setup.checkbox7:SetChecked( self.settings.stance.threat );
  	self.setup.checkbox11:SetChecked( self.settings.ward.timer );
    
    il={"Block Stance", "Parry Stance", "Overpower", "Threat Stance"};
	self.setup.dropdown1 = KragenPlugs.DUInterface.DropDownBox(il);
	self.setup.dropdown1:SetParent(self.setup.bg);
	self.setup.dropdown1:SetPosition(20,305);
	self.setup.dropdown1:SetZOrder(99); -- can be less, but should be higher than others to allow the drop down to cover other elements
 	il={"Block Stance", "Parry Stance", "Overpower", "Threat Stance"};
	self.setup.dropdown2 = KragenPlugs.DUInterface.DropDownBox(il);
	self.setup.dropdown2:SetParent(self.setup.bg);
	self.setup.dropdown2:SetPosition(215,305);
	self.setup.dropdown2:SetZOrder(99); -- can be less, but should be higher than others to allow the drop down to cover other elements
	
	self.setup.dropdown1.SetIndex(self.settings.stance.primary);
    self.setup.dropdown2.SetIndex(self.settings.stance.secondary);
	self.setup:SetText("KB: Guardian");
end

-- save settings when window is closed
function GuardBars:SetupClosing()
    self.settings.block.active = self.setup.checkbox1:GetChecked();
	self.settings.parry.active = self.setup.checkbox2:GetChecked();
	self.settings.ward.active = self.setup.checkbox3:GetChecked();
	self.settings.tables.active = self.setup.checkbox4:GetChecked();
	self.settings.overpower.active = self.setup.checkbox5:GetChecked();
	self.settings.stance.active = self.setup.checkbox6:GetChecked();
	self.settings.stance.primary = self.setup.dropdown1:GetIndex();
	self.settings.stance.secondary = self.setup.dropdown2:GetIndex();
	self.settings.stance.threat = self.setup.checkbox7:GetChecked();
	self.settings.ward.timer = self.setup.checkbox11:GetChecked();
	if (self.settings.stance.threat) then
		self.window[6].bar[1].slot[1]:ChangeTotal(4);
	else
	    self.window[6].bar[1].slot[1]:ChangeTotal(3);
	end
	
	self.window[1].display(self.settings.block.active);
	self.window[2].display(self.settings.parry.active);
	self.window[3].display(self.settings.ward.active);
	self.window[4].display(self.settings.tables.active);
	self.window[5].display(self.settings.overpower.active);
	self.window[6].display(self.settings.stance.active);
	
	-- SET WINDOW OPACITY
	self.window[1]:SetOpacity(settings.opacity);
	self.window[2]:SetOpacity(settings.opacity);
	self.window[3]:SetOpacity(settings.opacity);
	self.window[4]:SetOpacity(settings.opacity);
	self.window[5]:SetOpacity(settings.opacity);
	self.window[6]:SetOpacity(settings.opacity);
	
	self:SaveSettings();
end