import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Utils";
import "KragenPlugs.KragenBars";

Slot = class (Turbine.UI.Lotro.Quickslot)

function Slot:Constructor ()
	Turbine.UI.Lotro.Quickslot.Constructor( self );
	
	-- Variable for Multi-Level Quickslots
	self.currentshortcut = 1;
	self.totalshortcuts = 0;
	self.shortcut = { };
	
	-- Booleans for changing on scroll or click
	self.scroll = false;
	self.click = false;
	
	
	-- Change Multi-Level quickslot on scroll if scroll is true
	self.MouseWheel = function (sender, args)
		if (self.scroll) then
			self.currentshortcut = self.currentshortcut + 1;
			if (self.currentshortcut > self.totalshortcuts) then
				self.currentshortcut = 1;
			end
			
			self:SetShortcut( Turbine.UI.Lotro.Shortcut( self.shortcut[self.currentshortcut].Type, self.shortcut[self.currentshortcut].Data ) );
		end
	end
	
	-- Change Multi-Level quickslot on click if click is true
	self.MouseClick = function (sender, args)
		if (self.click) then
			self.currentshortcut = self.currentshortcut + 1;
			if (self.currentshortcut > self.totalshortcuts) then
				self.currentshortcut = 1;
			end
			
			self:SetShortcut( Turbine.UI.Lotro.Shortcut( self.shortcut[self.currentshortcut].Type, self.shortcut[self.currentshortcut].Data ) );
		end
	end
end

-- Add Multi-Level Shortcut
function Slot:MultiShortcut(type, data)
	self.totalshortcuts = self.totalshortcuts + 1;
	self.shortcut[self.totalshortcuts] = { };
	self.shortcut[self.totalshortcuts].Type = type;
	self.shortcut[self.totalshortcuts].Data = data;
end

-- Change Multi Level Shortcut
function Slot:ChangeMultiShortcut(num, type, data)
	self.shortcut[num].Type = type;
	self.shortcut[num].Data = data;
end

-- Change total shortcuts
function Slot:ChangeTotal(num)
	self.totalshortcuts = num;
	if (self.currentshortcut > self.totalshortcuts) then
        self.currentshortcut = 1;
		self:SetShortcut( Turbine.UI.Lotro.Shortcut( self.shortcut[self.currentshortcut].Type, self.shortcut[self.currentshortcut].Data ) );
	end
end

-- Set Currently Displayed multi-level shortcut
function Slot:SetMulti(num)
	self.currentshortcut = num;
	self:SetShortcut( Turbine.UI.Lotro.Shortcut( self.shortcut[self.currentshortcut].Type, self.shortcut[self.currentshortcut].Data ) );
end

-- Set Scroll Boolean
function Slot:SetScroll(bol)
	self.scroll = bol;
end

-- Set Click Boolean
function Slot:SetClick(bol)
	self.click = bol;
end