import "Turbine.Gameplay";
import "Turbine.UI";
import "PengorosPlugins.BuffBars";
import "PengorosPlugins.UI";

IgnoreWindow = class(PengorosPlugins.BuffBars.ListWindow);

function IgnoreWindow:Constructor()
    PengorosPlugins.BuffBars.ListWindow.Constructor(self);
    
    self:SetText(L["Ignored Effects"]);
    self.Closed = function(sender, args)
        -- save the position
        Settings.instance.ignoreX, Settings.instance.ignoreY = self:GetPosition();
        Settings.Save();
    end
    
    -- restore the position if there is one
    if (Settings.instance.ignoreX ~= nil) then
        self:SetPosition(PengorosPlugins.Utils.ValidatePosition(Settings.instance.ignoreX, Settings.instance.ignoreY, self:GetWidth(), self:GetHeight()));
    end
    
    self.GetList = function(sender, settings)
        return settings.ignored;
    end
    
    self.ResetList = function(sender, settings)
        settings:ResetIgnored();
    end
    
    self.AddItemToList = function(sender, settings, item)
        settings:AddIgnoredEffect(item);
    end
end
