import "Turbine.Gameplay";

EffectManager = {};

-- listeners
EffectManager.listeners = {};

-- effect hooks
EffectManager.player = PengorosPlugins.Utils.GetPlayer();
local effects = EffectManager.player:GetEffects();
effects.EffectAdded = function(sender, args)
    local effect = EffectManager.player:GetEffects():Get(args.Index);
    EffectManager.AddEffect(effect);
end
effects.EffectRemoved = function(sender, args)
    EffectManager.RemoveEffect(args.Effect);
end
effects.EffectsCleared = function(sender, args)
    EffectManager.ClearEffects();
end

function EffectManager.AddListener(listener)
    -- make sure it isn't in the list already
    EffectManager.RemoveListener(listener);
    table.insert(EffectManager.listeners, listener);
end

function EffectManager.RemoveListener(listener)
    local i;
    for i = 1, table.getn(EffectManager.listeners) do
        if (EffectManager.listeners[i] == listener) then
            table.remove(EffectManager.listeners, i);
            break;
        end
    end
end

function EffectManager.GetEffects()
    return EffectManager.player:GetEffects();
end

function EffectManager.AddEffect(effect)
    local i;
    for i = 1, table.getn(EffectManager.listeners) do
        if (type(EffectManager.listeners[i].EffectAdded) == "function") then
            EffectManager.listeners[i]:EffectAdded(effect);
        end
    end
end

function EffectManager.RemoveEffect(effect)
    local i;
    for i = 1, table.getn(EffectManager.listeners) do
        if (type(EffectManager.listeners[i].EffectRemoved) == "function") then
            EffectManager.listeners[i]:EffectRemoved(effect);
        end
    end
end

function EffectManager.ClearEffects()
    local i;
    for i = 1, table.getn(EffectManager.listeners) do
        if (type(EffectManager.listeners[i].EffectsCleared) == "function") then
            EffectManager.listeners[i]:EffectsCleared();
        end
    end
end
