import "Turbine.Gameplay";

PlayerManager = {};

-- listeners
PlayerManager.listeners = {};

-- trap the player events
PlayerManager.player = PengorosPlugins.Utils.GetPlayer();
PlayerManager.player.InCombatChanged = function(sender, args)
    PlayerManager.FireInCombat();
end
PlayerManager.player.MoraleChanged = function(sender, args)
    PlayerManager.FireMorale();
end
PlayerManager.player.PowerChanged = function(sender, args)
    PlayerManager.FirePower();
end

function PlayerManager.GetPlayer()
    return PlayerManager.player;
end

function PlayerManager.AddListener(listener)
    -- make sure it isn't in the list already
    PlayerManager.RemoveListener(listener);
    table.insert(PlayerManager.listeners, listener);
end

function PlayerManager.RemoveListener(listener)
    local i;
    for i = 1, table.getn(PlayerManager.listeners) do
        if (PlayerManager.listeners[i] == listener) then
            table.remove(PlayerManager.listeners, i);
            break;
        end
    end
end

function PlayerManager.FireInCombat()
    local i;
    local inCombat = PlayerManager.player:IsInCombat();
    for i = 1, table.getn(PlayerManager.listeners) do
        if (type(PlayerManager.listeners[i].InCombatChanged) == "function") then
            PlayerManager.listeners[i]:InCombatChanged(inCombat);
        end
    end
end

function PlayerManager.FireMorale()
    local i;
    for i = 1, table.getn(PlayerManager.listeners) do
        if (type(PlayerManager.listeners[i].MoraleChanged) == "function") then
            PlayerManager.listeners[i]:MoraleChanged(PlayerManager.player);
        end
    end
end

function PlayerManager.FirePower()
    local i;
    for i = 1, table.getn(PlayerManager.listeners) do
        if (type(PlayerManager.listeners[i].PowerChanged) == "function") then
            PlayerManager.listeners[i]:PowerChanged(PlayerManager.player);
        end
    end
end
